<?php
/**
 * Plugin Name: CK Instant Delivery
 * Plugin URI:  https://mahdimohebi.ir/my-plugins/
 * Description: CK instant delivery - shortcode [mmckid_form]
 * Version:     1.1.3
 * Author:      Mahdi Mohebi
 * Author URI:  https://mahdimohebi.ir/
 * License:     GPLv2 or later
 * License URI: http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 * Text Domain: mmckid
 * Domain Path: /languages
 * 
 */
 
//
//mmckid
  
if ( ! defined( 'ABSPATH' ) ) {
	die( 'Invalid request.' );
}



define("mmckid_url", plugin_dir_url(__FILE__));

if ( ! class_exists( 'mmckid' ) ) {
	class mmckid {
		private static $settings;
		private function __construct() {
		} 
		public static $parsian_login_account = "gGU0Kexx65iUenjUNT6Y";
		public static $redirect_uri = "";//WC()->api_request_url('WC_Parsian_Gateway');
		public static $title = "پرداخت از درگاه بانک پارسیان";
		public static $description = "پرداخت امن به وسیله کلیه کارت های عضو شتاب از طریق بانک پارسیان";
		public static $success_massage = "با تشکر از شما . سفارش شما با موفقیت پرداخت شد .";
		public static $failed_massage = "پرداخت شما ناموفق بوده است . لطفا مجددا تلاش نمایید یا در صورت بروز اشکال با مدیر سایت تماس بگیرید .";
		public static $cancelled_massage = "پرداخت به دلیل انصراف شما ناتمام باقی ماند .";
		//public static $msg['message'] = '';
		//public static $msg['class'] = '';
		public static $id = 'parsian';
		public static $method_title = 'بانک پارسیان';
		
		
		public static function init_actions() {
			$plugin_data = get_file_data(__FILE__, [
				'Version' => 'Version',
				'TextDomain' => 'Text Domain'
			], 'plugin');
			//$mmckid_plugin_data = get_plugin_data( __FILE__ );
			define("mmckid_version",$plugin_data['Version']); 
			
			register_activation_hook( __FILE__, array( __CLASS__, 'activate' ) );
			register_deactivation_hook(__FILE__, array( __CLASS__, 'deactivat'));
			register_uninstall_hook( __FILE__, array( __CLASS__, 'uninstall' ) );
			add_shortcode('mmckid_form', array( __CLASS__ , 'echo_shortcode'));
			//add_action( 'update_option_mmckid_settings',  array( __CLASS__,'mmckid_options_updated'), 10, 2 );
			add_action( 'admin_menu', array( __CLASS__ , 'add_admin_menu' ) );
			//add_action( 'wp_footer', array( __CLASS__ , 'add_to_footer' ) );
			//add_action( 'admin_init', array( __CLASS__ , 'settings_init' ) );
			add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), array( __CLASS__, 'add_settings_link' ), 10, 2 );
			add_action( 'admin_enqueue_scripts', array( __CLASS__, 'enqueue_backend' ) );
			add_action( 'wp_enqueue_scripts', array( __CLASS__, 'enqueue_front' ) );
			add_action( 'wp_ajax_mmckid_ajax', array( __CLASS__,'ajax_request') );
			add_action( 'wp_ajax_nopriv_mmckid_ajax', array( __CLASS__,'ajax_request') );
			add_action( 'plugins_loaded', array( __CLASS__,'load_textdomain'));
			
			
			
			add_action( 'init', array ( __CLASS__, 'reg_taxo') ,10);
			
			add_action( 'salepoint_add_form_fields', array ( __CLASS__, 'add_salepoint_term' ), 10, 2 );
			add_action( 'created_salepoint', array ( __CLASS__, 'save_salepoint_term' ), 10, 2 );
			add_action( 'salepoint_edit_form_fields', array ( __CLASS__, 'update_salepoint_term' ), 10, 2 );
			add_action( 'edited_salepoint', array ( __CLASS__, 'updated_salepoint_term' ), 10, 2 );
			add_action( 'admin_enqueue_scripts', array( __CLASS__, 'load_media' ) );
			add_action( 'admin_footer', array ( __CLASS__, 'add_script' ) );
			
			
			//add_action( 'category_add_form_fields', array ( __CLASS__, 'add_salepoint_term' ), 10, 2 );
			//add_action( 'created_category', array ( __CLASS__, 'save_salepoint_term' ), 10, 2 );
			//add_action( 'category_edit_form_fields', array ( __CLASS__, 'update_salepoint_term' ), 10, 2 );
			//add_action( 'edited_category', array ( __CLASS__, 'updated_salepoint_term' ), 10, 2 );
			//add_action( 'admin_enqueue_scripts', array( __CLASS__, 'load_media' ) );
			//add_action( 'admin_footer', array ( __CLASS__, 'add_script' ) );
			
			
			
			
			
		} 
		
		
		public static function reg_taxo()  {
			$labels = array(
				'name'                       => _x( 'شعبه', 'شعبه ها', 'mmckid' ),
				'singular_name'              => _x( 'شعبه', 'شعبه', 'mmckid' ),
				'menu_name'                  => __( 'شعبه ها', 'mmckid' ),
				'all_items'                  => __( 'همه', 'mmckid' ),
				'parent_item'                => __( 'مادر', 'mmckid' ),
				'parent_item_colon'          => __( 'مادر : ', 'mmckid' ),
				'new_item_name'              => __( 'نام', 'mmckid' ),
				'add_new_item'               => __( 'افزودن', 'mmckid' ),
				'edit_item'                  => __( 'ویرایش', 'mmckid' ),
				'update_item'                => __( 'بروزرسانی', 'mmckid' ),
				'view_item'                  => __( 'View Item', 'mmckid' ),
				'separate_items_with_commas' => __( 'Separate items with commas', 'mmckid' ),
				'add_or_remove_items'        => __( 'Add or remove items', 'mmckid' ),
				'choose_from_most_used'      => __( 'Choose from the most used', 'mmckid' ),
				'popular_items'              => __( 'Popular Items', 'mmckid' ),
				'search_items'               => __( 'Search Items', 'mmckid' ),
				'not_found'                  => __( 'Not Found', 'mmckid' ),
				'no_terms'                   => __( 'No items', 'mmckid' ),
				'items_list'                 => __( 'Items list', 'mmckid' ),
				'items_list_navigation'      => __( 'Items list navigation', 'mmckid' ),
			);
			$args = array(
				'labels'                     => $labels,
				'hierarchical'               => true,
				'public'                     => true,
				'show_ui'                    => true,
				'show_admin_column'          => true,
				'show_in_nav_menus'          => true,
				'show_tagcloud'              => false,
			);
			register_taxonomy( 'salepoint', array( 'product' ), $args );
		}

		
		
		public static function load_media() {
		 wp_enqueue_media();
		}
		 
		 /*
		  * Add a form field in the new category page
		  * @since 1.0.0
		 */
		 public function add_salepoint_term ( $taxonomy ) { ?>
		   <div class="form-field term-group">
			 <label for="category-image-id"><?php _e('تصویر شعبه', 'mmckid'); ?></label>
			 <input type="hidden" id="category-image-id" name="category-image-id" class="custom_media_url" value="">
			 <div id="category-image-wrapper"></div>
			 <p>
			   <input type="button" class="button button-secondary ct_tax_media_button" id="ct_tax_media_button" name="ct_tax_media_button" value="<?php _e( 'انتخاب تصویر', 'mmckid' ); ?>" />
			   <input type="button" class="button button-secondary ct_tax_media_remove" id="ct_tax_media_remove" name="ct_tax_media_remove" value="<?php _e( 'حذف تصویر', 'mmckid' ); ?>" />
			</p>
		   </div>
		   
		   
		   
		   
		   <script type="text/javascript" src="<?php echo mmckid_url.'leaflet/leaflet.js'; ?>"></script>
			<script type="text/javascript" src="<?php echo mmckid_url.'assets/back.js?v='.mmckid_version; ?>"></script>
			<link href="<?php echo mmckid_url.'assets/back.css?v='.mmckid_version; ?>" rel="stylesheet">
			<link href="<?php echo mmckid_url.'leaflet/leaflet.css' ?>" rel="stylesheet">
			<script>
			
				jQuery(document).ready( function () {

					//ایران#map=5/32.621/53.701
					//تهران //#map=11/35.7157/51.3477
					var map = L.map("map").setView([35.7157, 51.3477], 11);

					L.tileLayer('https://{s}.tile.osm.org/{z}/{x}/{y}.png', {
						attribution: '&copy; <a href="https://osm.org/copyright">OpenStreetMap</a> contributors'
					}).addTo(map);
					
					setTimeout(function(){ map.invalidateSize()}, 1000);
					//setInterval(function (){
					//  map.invalidateSize();
					//}, 100);
					 jQuery("a#sub_req").click(function () {
					   map.invalidateSize();
					});
					 jQuery("button#nextBtn").click(function () {
					   map.invalidateSize();
					});
					jQuery("button#prevBtn").click(function () {
					   map.invalidateSize();
					});
					

					var currentMarker;

					map.on("click", function (event) {
						if (currentMarker) {
							currentMarker._icon.style.transition = "transform 0.3s ease-out";
							currentMarker._shadow.style.transition = "transform 0.3s ease-out";
							
							currentMarker.setLatLng(event.latlng);
							
							setTimeout(function () {
								currentMarker._icon.style.transition = null;
								currentMarker._shadow.style.transition = null;
							}, 300);
							document.getElementById('lat-lng').value = event.latlng.lat + ','+ event.latlng.lng ;
							return;
						}
						
						currentMarker = L.marker(event.latlng, {
							draggable: true
						}).addTo(map).on("click", function () {
							event.originalEvent.stopPropagation();
						});
						document.getElementById('lat-lng').value = event.latlng.lat + ','+ event.latlng.lng ;
						//console.log(event.latlng);
						
					});

					/*
					//for adding new marker plus this
					//<button id="done">Done moving current marker</button>
					document.getElementById("done").addEventListener("click", function () {
						currentMarker = null;
					});
					*/
					
				} );


			
			</script>
			
			<div id="map" style="height: 300px;width: 95%;"></div>
		   <div class="form-field form-required mmckid-location-wrap">
				<label for="lat-lng">آدرس جغرافیایی</label>
				<input name="lat-lng" id="lat-lng" type="text" value="" style="direction:ltr;text-align: left;" size="40" aria-required="true">
				<p style="direction:ltr;text-align: left;">35.699965, 51.437399</p>
			</div>
			
			<div class="form-field form-required mmckid_point_id_wrap">
				<label for="mmckid_point_id">آیدی</label>
				<input name="mmckid_point_id" id="mmckid_point_id" type="number" value="" style="" size="40" aria-required="true">
				<p style="">آیدی شعبه در سامانه </p>
			</div>
			
			<div class="form-field form-required mmckid_point_kilometer_wrap">
				<label for="mmckid_point_kilometer">شعاع ارسال</label>
				<input name="mmckid_point_kilometer" id="mmckid_point_kilometer" type="number" value="" style="" size="40" aria-required="true">
				<p style="">شعاع ارسال بسته به کیلومتر</p>
			</div>
			<div class="form-field form-required mmckid_point_start_time_wrap">
				<label for="mmckid_point_start_time">ساعت شروع</label>
				<input name="mmckid_point_start_time" id="mmckid_point_start_time" type="time" value="" style="" size="40" aria-required="true">
				<p style="">ساعتی که شعبه باز میشه و آماده خدماته</p>
			</div>
			<div class="form-field form-required mmckid_point_end_time_wrap">
				<label for="mmckid_point_end_time">ساعت پایان</label>
				<input name="mmckid_point_end_time" id="mmckid_point_end_time" type="time" value="" style="" size="40" aria-required="true">
				<p style="">ساعت پایان کار شعبه</p>
			</div>

		 <?php
		 }
		 
		 /*
		  * Save the form field
		  * @since 1.0.0
		 */
		 public static function save_salepoint_term ( $term_id, $tt_id ) {
		   if( isset( $_POST['category-image-id'] ) && '' !== $_POST['category-image-id'] ){
			 $image = $_POST['category-image-id'];
			 add_term_meta( $term_id, 'category-image-id', $image, true );
		   }
		   
		   if ( isset( $_POST['lat-lng'] ) ) {
				update_term_meta ( $term_id, 'mmckid_lat_lng', $_POST['lat-lng'] );  
			}
			
			if ( isset( $_POST['mmckid_point_id'] ) ) {
				update_term_meta ( $term_id, 'mmckid_point_id', $_POST['mmckid_point_id'] );  
			}
			
			if ( isset( $_POST['mmckid_point_kilometer'] ) ) {
				update_term_meta ( $term_id, 'mmckid_point_kilometer', $_POST['mmckid_point_kilometer'] );  
			}
			if ( isset( $_POST['mmckid_point_start_time'] ) ) {
				update_term_meta ( $term_id, 'mmckid_point_start_time', $_POST['mmckid_point_start_time'] );  
			}
			if ( isset( $_POST['mmckid_point_end_time'] ) ) {
				update_term_meta ( $term_id, 'mmckid_point_end_time', $_POST['mmckid_point_end_time'] );  
			}
			
		 }
		 
		 /*
		  * Edit the form field
		  * @since 1.0.0
		 */
		 public static function update_salepoint_term ( $term, $taxonomy ) { 
			
			$mmckid_lat_lng = get_term_meta ( $term -> term_id, 'mmckid_lat_lng', true );
			$mmckid_point_id = get_term_meta ( $term -> term_id, 'mmckid_point_id', true );
			$mmckid_point_kilometer = get_term_meta ( $term -> term_id, 'mmckid_point_kilometer', true );
			$mmckid_point_start_time = get_term_meta ( $term -> term_id, 'mmckid_point_start_time', true );
			$mmckid_point_end_time = get_term_meta ( $term -> term_id, 'mmckid_point_end_time', true );
			$mmckid_lat_lng_array = explode(',', $mmckid_lat_lng);

			?>
		   <tr class="form-field term-group-wrap">
			 <th scope="row">
			   <label for="category-image-id"><?php _e( 'تصویر شعبه', 'mmckid' ); ?></label>
			 </th>
			 <td>
			   <?php $image_id = get_term_meta ( $term -> term_id, 'category-image-id', true ); ?>
			   <input type="hidden" id="category-image-id" name="category-image-id" value="<?php echo $image_id; ?>">
			   <div id="category-image-wrapper">
				 <?php if ( $image_id ) { ?>
				   <?php echo wp_get_attachment_image ( $image_id, 'thumbnail' ); ?>
				 <?php } ?>
			   </div>
			   <p>
				 <input type="button" class="button button-secondary ct_tax_media_button" id="ct_tax_media_button" name="ct_tax_media_button" value="<?php _e( 'انتخاب تصویر', 'mmckid' ); ?>" />
				 <input type="button" class="button button-secondary ct_tax_media_remove" id="ct_tax_media_remove" name="ct_tax_media_remove" value="<?php _e( 'حذف تصویر', 'mmckid' ); ?>" />
			   </p>
			 </td>
		   </tr>
		   
		   
		   <script type="text/javascript" src="<?php echo mmckid_url.'leaflet/leaflet.js'; ?>"></script>
			<script type="text/javascript" src="<?php echo mmckid_url.'assets/back.js?v='.mmckid_version; ?>"></script>
			<link href="<?php echo mmckid_url.'assets/back.css?v='.mmckid_version; ?>" rel="stylesheet">
			<link href="<?php echo mmckid_url.'leaflet/leaflet.css' ?>" rel="stylesheet">
			<script>
				var mmckid_lat = <?php echo "" . $mmckid_lat_lng_array[0] . "" ;?>;
				var mmckid_lng = <?php echo "" . $mmckid_lat_lng_array[1] . "" ;?>;
				jQuery(document).ready( function () {
					//ایران#map=5/32.621/53.701
					//تهران //#map=11/35.7157/51.3477
					var map = L.map("map").setView([mmckid_lat, mmckid_lng], 11);

					L.tileLayer('https://{s}.tile.osm.org/{z}/{x}/{y}.png', {
						attribution: '&copy; <a href="https://osm.org/copyright">OpenStreetMap</a> contributors'
					}).addTo(map);
					var currentMarker = L.marker([mmckid_lat, mmckid_lng]).addTo(map);
					setTimeout(function(){ map.invalidateSize()}, 1000);
					//setInterval(function (){
					//  map.invalidateSize();
					//}, 100);
					 jQuery("a#sub_req").click(function () {
					   map.invalidateSize();
					});
					 jQuery("button#nextBtn").click(function () {
					   map.invalidateSize();
					});
					jQuery("button#prevBtn").click(function () {
					   map.invalidateSize();
					});
					

					//var currentMarker;

					map.on("click", function (event) {
						if (currentMarker) {
							currentMarker._icon.style.transition = "transform 0.3s ease-out";
							currentMarker._shadow.style.transition = "transform 0.3s ease-out";
							
							currentMarker.setLatLng(event.latlng);
							
							setTimeout(function () {
								currentMarker._icon.style.transition = null;
								currentMarker._shadow.style.transition = null;
							}, 300);
							document.getElementById('lat-lng').value = event.latlng.lat + ','+ event.latlng.lng ;
							return;
						}
						
						currentMarker = L.marker(event.latlng, {
							draggable: true
						}).addTo(map).on("click", function () {
							event.originalEvent.stopPropagation();
						});
						document.getElementById('lat-lng').value = event.latlng.lat + ','+ event.latlng.lng ;
						//console.log(event.latlng);
						
					});

					/*
					//for adding new marker plus this
					//<button id="done">Done moving current marker</button>
					document.getElementById("done").addEventListener("click", function () {
						currentMarker = null;
					});
					*/
					
				} );

			</script>
			<tr class="form-field term-group-wrap">
			   <th scope="row">
					<label for="lat-lng">آدرس جغرافیایی</label>
				</th>
			   <th scope="row">
					<div id="map" style="height: 300px;width: 95%;"></div>
					<input name="lat-lng" id="lat-lng" type="text" value="<?php if($mmckid_lat_lng != false ){echo $mmckid_lat_lng;} ?>" style="direction:ltr;text-align: left;margin-top: 10px;" size="40" aria-required="true">
				</th>
		   </tr>
			<tr class="form-field term-group-wrap">
					<th scope="row">
						<label for="mmckid_point_id">آیدی</label>
					</th>
					<th scope="row">
						<input name="mmckid_point_id" id="mmckid_point_id" type="number" value="<?php if($mmckid_point_id != false ){echo $mmckid_point_id;} ?>" style="" size="40" aria-required="true">
						<p style="">آیدی شعبه در سامانه </p>
					</th>
				</div>
		   </tr>
		   
			<tr class="form-field term-group-wrap">
					<th scope="row">
						<label for="mmckid_point_kilometer">شعاع ارسال</label>
					</th>
					<th scope="row">
						<input name="mmckid_point_kilometer" id="mmckid_point_kilometer" type="number" value="<?php if($mmckid_point_kilometer != false ){echo $mmckid_point_kilometer;} ?>" style="" size="40" aria-required="true">
						<p style="">شعاع ارسال بسته به کیلومتر</p>
					</th>
				</div>
		   </tr>
		   <tr class="form-field term-group-wrap">
					<th scope="row">
						<label for="mmckid_point_start_time">ساعت شروع</label>
					</th>
					<th scope="row">
						<input name="mmckid_point_start_time" id="mmckid_point_start_time" type="time" value="<?php if($mmckid_point_start_time != false ){echo $mmckid_point_start_time;} ?>" style="" size="40" aria-required="true">
						<p style=""></p>
					</th>
				</div>
		   </tr>
		   <tr class="form-field term-group-wrap">
					<th scope="row">
						<label for="mmckid_point_end_time">ساعت پایان</label>
					</th>
					<th scope="row">
						<input name="mmckid_point_end_time" id="mmckid_point_end_time" type="time" value="<?php if($mmckid_point_end_time != false ){echo $mmckid_point_end_time;} ?>" style="" size="40" aria-required="true">
						<p style=""></p>
					</th>
				</div>
		   </tr>
		   <tr class="form-field term-group-wrap">
					<th scope="row">
						<label for="mmckid_point_end_time">شعبه تعطیل است ؟</label>
					</th>
					<th scope="row">
						<select  class="form-control" id="mmckid_point_closed" name="mmckid_point_closed">
							<?php 
							$mmckid_point_closed = get_term_meta ( $term -> term_id, 'mmckid_point_closed', true );
							if($mmckid_point_closed !="yes"){$mmckid_point_closed = 'no';}
							$mmckid_point_closed_array = array(
								'no' => 'خیر',
								'yes' =>'بله',
							);
							foreach ( $mmckid_point_closed_array as $key => $type ) {
								$selected = "";
								if($mmckid_point_closed == $key ){
									$selected = "selected";
								}
								echo "<option value='".$key."' ".$selected."  >".$type."</option>";
							}
							?>
						</select>
						<p style=""></p>
					</th>
				</div>
		   </tr>
		   
		   
		   
		 <?php
		 }

		/*
		 * Update the form field value
		 * @since 1.0.0
		 */
		 public static function updated_salepoint_term ( $term_id, $tt_id ) {
			 
			 
			 
		   if( isset( $_POST['category-image-id'] ) && '' !== $_POST['category-image-id'] ){
			 $image = $_POST['category-image-id'];
			 update_term_meta ( $term_id, 'category-image-id', $image );
		   } else {
			 update_term_meta ( $term_id, 'category-image-id', '' );
		   }
		   
		   if ( isset( $_POST['lat-lng'] ) ) {
				update_term_meta ( $term_id, 'mmckid_lat_lng', $_POST['lat-lng'] );  
			}
			
			if ( isset( $_POST['mmckid_point_id'] ) ) {
				update_term_meta ( $term_id, 'mmckid_point_id', $_POST['mmckid_point_id'] );  
			}
			if ( isset( $_POST['mmckid_point_kilometer'] ) ) {
				update_term_meta ( $term_id, 'mmckid_point_kilometer', $_POST['mmckid_point_kilometer'] );  
			}
			if ( isset( $_POST['mmckid_point_start_time'] ) ) {
				update_term_meta ( $term_id, 'mmckid_point_start_time', $_POST['mmckid_point_start_time'] );  
			}
			if ( isset( $_POST['mmckid_point_end_time'] ) ) {
				update_term_meta ( $term_id, 'mmckid_point_end_time', $_POST['mmckid_point_end_time'] );  
			}
			if ( isset( $_POST['mmckid_point_closed'] ) ) {
				update_term_meta ( $term_id, 'mmckid_point_closed', $_POST['mmckid_point_closed'] );  
			}
			
		 }

		/*
		 * Add script
		 * @since 1.0.0
		 */
		 public static function add_script() { ?>
		   <script>
			 jQuery(document).ready( function($) {
			   function ct_media_upload(button_class) {
				 var _custom_media = true,
				 _orig_send_attachment = wp.media.editor.send.attachment;
				 $('body').on('click', button_class, function(e) {
				   var button_id = '#'+$(this).attr('id');
				   var send_attachment_bkp = wp.media.editor.send.attachment;
				   var button = $(button_id);
				   _custom_media = true;
				   wp.media.editor.send.attachment = function(props, attachment){
					 if ( _custom_media ) {
					   $('#category-image-id').val(attachment.id);
					   $('#category-image-wrapper').html('<img class="custom_media_image" src="" style="margin:0;padding:0;max-height:100px;float:none;" />');
					   $('#category-image-wrapper .custom_media_image').attr('src',attachment.url).css('display','block');
					 } else {
					   return _orig_send_attachment.apply( button_id, [props, attachment] );
					 }
					}
				 wp.media.editor.open(button);
				 return false;
			   });
			 }
			 ct_media_upload('.ct_tax_media_button.button'); 
			 $('body').on('click','.ct_tax_media_remove',function(){
			   $('#category-image-id').val('');
			   $('#category-image-wrapper').html('<img class="custom_media_image" src="" style="margin:0;padding:0;max-height:100px;float:none;" />');
			 });
			 $(document).ajaxComplete(function(event, xhr, settings) {
			   var queryStringArr = settings.data.split('&');
			   if( $.inArray('action=add-tag', queryStringArr) !== -1 ){
				 var xml = xhr.responseXML;
				 $response = $(xml).find('term_id').text();
				 if($response!=""){
				   // Clear the thumb image
				   $('#category-image-wrapper').html('');
				 }
			   }
			 });
		   });
		 </script>
		 <?php }

		
		
		
		
		
		
		
		public static function load_textdomain() {
			load_plugin_textdomain( 'mmckid', false, basename( dirname( __FILE__ ) ) . '/languages' ); 
		} 
		public static function ajax_request() {
			self::handel_ajax();
			die();
		}
		public static function handel_ajax(){
			if(isset($_POST) and isset($_POST['ajax_type']) and $_POST['ajax_type']=='get_search_results'  ){
				$user_lat_lng = $_POST['lat_lng'];
				$hazine_ersal = $_POST['hazine_ersal'];
				$dist_meter = $_POST['dist_meter'];
				$term_lat_lng = get_term_meta ( $_POST['term_id'], 'mmckid_lat_lng', true );
				$mmckid_point_id = get_term_meta ( $_POST['term_id'], 'mmckid_point_id', true );
				$url = "http://portal.cakeekhooneh.com/api/GetAffiliateMenu?affiliateid=".$mmckid_point_id;
				$client = curl_init($url);
				curl_setopt($client,CURLOPT_RETURNTRANSFER,true);
				$response = curl_exec($client);
				
				$product_stock_array = json_decode($response);
				
				$query = new WP_Query(
					array( 
						'post_type' => 'product',
						'posts_per_page' => -1,
						'post_status' => 'publish',
						'tax_query' => 
							array( 
								array(
									'taxonomy'      => 'salepoint',
									'field'         => 'term_id', // can be 'term_id', 'slug' or 'name'
									'terms'         => array($_POST['term_id']),
								),
							),
						)
					);
				$posts = $query->posts;
				//var_dump($posts);
				$data = array();
				$has_post = 'no';
				if(!empty($posts)){
					$has_post = 'yes';
					foreach($posts as $index => $p_obj){
						$array = array();
						$stock = 0 ;
						foreach($product_stock_array as $object){
							if($object->WebPreSaleCode == $p_obj->ID or $object->WebCode == $p_obj->ID){
								if($object->Capacity > 0 ){
									$stock = $object->Capacity  ;
								}
							}
						}
						
						
						
						$array['post_id']= $p_obj->ID;
						$array['hazine_ersal']= $hazine_ersal;
						$array['dist_meter']= $dist_meter ;
						$array['title'] = $p_obj->post_title;
						$array['stock'] = (int)$stock;
						$array['term_id'] = $_POST['term_id'];
						$img_atts_array = wp_get_attachment_image_src(get_post_thumbnail_id( $p_obj->ID), 'full');
						$array['image_src_full'] = $img_atts_array[0];
						$img_atts_array = wp_get_attachment_image_src(get_post_thumbnail_id( $p_obj->ID), 'thumbnail');
						$array['image_src_thumbnail'] = $img_atts_array[0];
						$product = wc_get_product($p_obj->ID);
						$array['price'] = (int)$product->get_price();
						if( get_field('today_only',$p_obj->ID) ) {
							$array['roozaneh'] = true;
							//if($stock > 0){
								$data[] = $array;//فقط در این شرایط پست کنونی رو به آرایه اضافه می کنیم
							//}
						}else{
							$array['roozaneh'] = false;
							
							
						}
						
					}
				}
				$to_return = array('has_post'=>$has_post,'data' => $data);
				echo  json_encode($to_return);
			}elseif(isset($_POST) and isset($_POST['ajax_type']) and $_POST['ajax_type']=='pay_order' ){//pay_order
				//var_dump($_POST);
				$data = array();
				global $woocommerce;
				$user_info = get_userdata(get_current_user_id());
				$first_name = $user_info->first_name;
				$last_name = $user_info->last_name;
				$user_email = $user_info->user_email;
				$address = array(
				  'first_name' => $first_name,
				  'last_name'  => $last_name,
				  'company'    => '',
				  'email'      => $user_email ,
				  'phone'      => '',
				  'address_1'  => $_POST['cart_object']['address'],
				  'address_2'  => '',
				  'city'       => 'تهران',
				  'state'      => 'THR',
				  'postcode'   => '00000000',
				  'country'    => 'IR'
				);
				
				// Now we create the order
				$order_data = array(
					 'customer_id' => get_current_user_id(),
				);
				$order = wc_create_order($order_data);
				//$order->get_id();
				// The add_product() function below is located in /plugins/woocommerce/includes/abstracts/abstract_wc_order.php
				// Set the array for tax calculations
				$calculate_tax_for = array(
					'country' =>'IR',
					'state' => 'THR', // Can be set (optional)
					//'postcode' => '', // Can be set (optional)
					//'city' => '', // Can be set (optional)
				);

				// Optionally, set a total shipping amount
				$new_ship_price = $_POST['cart_object']['items'][0]['hazine_ersal'];

				// Get a new instance of the WC_Order_Item_Shipping Object
				$item = new WC_Order_Item_Shipping();

				$item->set_method_title( "تحویل فوری" );
				$item->set_method_id( "tahvil_fori" ); // set an existing Shipping method rate ID
				$item->set_total( $new_ship_price ); // (optional)
				$item->calculate_taxes($calculate_tax_for);
				$order->add_item( $item );
				$order->calculate_totals();
				foreach($_POST['cart_object']['items'] as $item){
					$count = 0;
					while($count < $item['count']){
					  $count++;
					  $order->add_product( get_product($item['post_id'])); 
					}
					//
					$order->set_address( $address, 'billing' );
					$order->calculate_totals();
					
				}	
				$order->update_status("wc-pending", 'فاکتور به شکل ای جکس ایجاد شد و آماده پرداخت است', TRUE); 
				$order->add_order_note('فاکتور به شکل ای جکس ایجاد شد و آماده پرداخت است');
				update_post_meta ( $order->get_id(), 'mmckid_is_instant_delivery' , "yes" );  
				update_post_meta ( $order->get_id(), 'mmckid_user_address' , $_POST['cart_object']['address']);  
				update_post_meta ( $order->get_id(), 'mmckid_user_lat_lng' , $_POST['cart_object']['lat_lng'] ); 
				update_post_meta ( $order->get_id(), 'mmckid_selected_salepoint_id' , $_POST['cart_object']['items'][0]['term_id'] ); 
				
				$data_return = self::receipt_page($order->get_id());
				//$data_return = array( 'status' => $status, 'order_id'=> $order_id , 'redirect_to_bank' => $redirect_to_bank);

				$the_term = get_term_by('id', $_POST['cart_object']['items'][0]['term_id'], 'salepoint');
				$to_return = array('sucsess'=>'yes','data' => $order  , 'point_name' => $the_term->name  ,'order_id' => $order->get_id(), 'bank' => $data_return );
				echo  json_encode($to_return);
				
			}
			
		}
		public static function add_admin_menu() {
			add_menu_page(
				__( 'ارسال فوری', 'mmckid' ),
				__( 'ارسال فوری', 'mmckid' ),
				'manage_options',
				'mmckid',
				array(__CLASS__,'options_page'),
				'dashicons-category'
			);
		}
		
		
		
		public static function enqueue_backend() {
			wp_enqueue_script("jquery");
			//wp_enqueue_script( 'jquery-ui-core', false, array('jquery') );
			//wp_enqueue_script( 'jquery-ui-selectable', false, array('jquery') );
			
			//wp_enqueue_style('back_css', plugins_url('assets/back.css',__FILE__ ),'',mmckid_version);
			//wp_enqueue_script('back_js', plugins_url('assets/back.js',__FILE__ ),array('jquery'),mmckid_version);
		}
		public static function enqueue_front(){
			
			wp_enqueue_script("jquery");
			//wp_enqueue_script( 'jquery-ui-core', false, array('jquery') );
			//wp_enqueue_script( 'jquery-ui-selectable', false, array('jquery') );
			
			//wp_enqueue_script('sr_front_js', plugins_url('assets/front.js',__FILE__ ),array('jquery'),mmckid_version);
			//$data = array('name_1'   => admin_url( 'admin-ajax.php' ),'a_value' => '10');
			//wp_localize_script('sr_front_js', 'pefix_handel', $data);
			//wp_enqueue_style('sr_front_css', plugins_url('assets/front.css',__FILE__ ),'',mmckid_version);
			//wp_enqueue_style('sr_front_csr_rtl', plugins_url('assets/front_rtl.css',__FILE__ ),'',mmckid_version);
		}
		public static function options_page() { 
		?>
			<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
			<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
			<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
			<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
			<script>
				<?php 
					$admin_ajax_url =  admin_url( 'admin-ajax.php' );
					echo "mmckid_admin_ajax_url = '".$admin_ajax_url."';";
					echo "mmckid_this_site_url = '".get_site_url()."';";//http://www.example.com
					//ایجاد کوکی برای ویریفای شخص حاضر در جاوا اسکریپت
					$mmckid_authentication = array('nonce' => wp_create_nonce('wp_rest'));
					?>var mmckid_authentication = <?php echo json_encode($mmckid_authentication) ?>;<?php
					?>var mmckid_cart_object = {};<?php
				?>
			</script>
			<script type="text/javascript" src="<?php echo mmckid_url.'assets/back.js?v='.mmckid_version; ?>"></script>
			<link href="<?php echo mmckid_url.'assets/back.css?v='.mmckid_version; ?>" rel="stylesheet">
			<style>@font-face {font-family: sahel;src: url(<?php echo mmckid_url.'assets/'; ?>sahel.woff);}@font-face {font-family: sahelb;src: url(<?php echo mmckid_url.'assets/'; ?>sahelb.woff);}</style>
			<div id="mmckid_main_wrapper">
				<div id="mmckid_main_inner" style="padding:30px;direction:rtl;">
					<h4 style=" padding: 20px; padding-right: 0;"> تنظیمات ارسال فوری  <div style="display:none;" class="mmckid_loading spinner-border text-primary"></div></h4>
					<form method="post">
						<div class="row">
							<div class="col-sm-4">
								<div class="form-group">
									<label for="mmckid_set_1">تنظیم 1</label>
									<input type="text" class="form-control" id="mmckid_set_1" value="<?php if (get_option( 'mmckid_set_1' )){echo get_option( 'mmckid_set_1' );} ?>">
									<?php //var_dump($post_types); ?>
								</div>
							</div>
							<div class="col-sm-4">
								<div class="form-group">
									<label for="mmckid_set_2"> تنظیم 2</label>
									<input type="text" class="form-control" id="mmckid_set_2" value="<?php if (get_option( 'mmckid_set_2' )){echo get_option( 'mmckid_set_2' );} ?>" >
								</div>
							</div>
							<div class="col-sm-4">
								<label for="mmckid_set_3"> تنظیم 3</label>
								<input type="text" class="form-control" id="mmckid_set_3" value="<?php if (get_option( 'mmckid_set_3' )){echo get_option( 'mmckid_set_3' );} ?>" >
							</div>
						</div>
						<button type="button" id="mmckid_send_save_setting" class="btn btn-primary" onclick="mmckid_save_settings()">ذخیره تنظیمات</button>
						<div id="mmckid_ajax_message" style="display:none;"></div>
					</form>
					
				</div>	
			</div>	
		<?php
		}
		public static function echo_shortcode() { 
			
			
			
			if (isset($_GET['is_callback']) and $_GET['is_callback']== 'yes'){
				//در حالت بازگشت از بانک هستیم
				$callback_result = self::callback();
				//array('status'=>'no','html_error'=>$html_error,'error_code'=>$error_code);
				//array('status'=>'yes','Token'=> $Token,'OrderId'=> $OrderId,'RRN'=> $RRN);
				if($callback_result['status']=='yes'){
					//echo "پرداخت شما با موفقیت انجام شد";
					//echo "<br>";
					//echo $callback_result['Token'];
					//echo "<br>";
					self::add_trip();
				}
				
				
			}else{
				$callback_result = array();
				if(!is_user_logged_in()){
					//wp_redirect( home_url().'/my-account/?redirect_to=instant-delivery' ); exit; 
					echo "<script>window.location.href = '". home_url()."/my-account/?redirect_to=instant-delivery"."';</script>";
					// Simulate a mouse click:
					//window.location.href = "x";
					// Simulate an HTTP redirect:
					//window.location.replace("x");
				}
			}
			
			$terms = get_terms( array(
				'taxonomy' => 'salepoint',
				'hide_empty' => false,
				'orderby' => 'name',
				'order' => 'ASC',
			) );
			$terms_array = json_decode(json_encode($terms), true);
			//echo '<div style="direction:ltr;padding:40px;">'. highlight_string(var_export($terms_array) ) .'</div>';
			$terms_new_array =array();
			foreach($terms_array as $array){
				$term_array = array();
				$term_array['term_id'] = $array['term_id'];
				$term_array['term_taxonomy_id'] = $array['term_taxonomy_id'];
				$term_array['count'] = $array['count'];
				$term_array['name'] = $array['name'];
				$term_array['slug'] = $array['slug'];
				$term_array['now'] = current_time( 'H:i' );
				
				
				
				$mmckid_image_id = get_term_meta ( $array['term_id'], 'category-image-id', true ); 
				$mmckid_lat_lng = get_term_meta ( $array['term_id'], 'mmckid_lat_lng', true );
				$mmckid_point_id = get_term_meta ( $array['term_id'], 'mmckid_point_id', true );
				$mmckid_point_start_time = get_term_meta ( $array['term_id'], 'mmckid_point_start_time', true );
				$mmckid_point_end_time = get_term_meta ( $array['term_id'], 'mmckid_point_end_time', true );
				$mmckid_point_kilometer = get_term_meta ( $array['term_id'], 'mmckid_point_kilometer', true );
				if($mmckid_image_id != false ){$term_array['mmckid_image_id'] = $mmckid_image_id;}else{$term_array['mmckid_image_id'] = '13561';}
				if($mmckid_lat_lng != false ){$term_array['mmckid_lat_lng'] = $mmckid_lat_lng;}else{$term_array['mmckid_lat_lng'] = '';}
				if($mmckid_point_id != false ){$term_array['mmckid_point_id'] = $mmckid_point_id;}else{$term_array['mmckid_point_id'] = '';}
				if($mmckid_point_start_time != false ){$term_array['start'] = $mmckid_point_start_time;}else{$term_array['start'] = '';}
				if($mmckid_point_end_time != false ){$term_array['end'] = $mmckid_point_end_time;}else{$term_array['end'] = '';}
				if($mmckid_point_kilometer != false ){$term_array['mmckid_point_kilometer'] = $mmckid_point_kilometer;}else{$term_array['mmckid_point_kilometer'] = '';}
				$img_atts_array = wp_get_attachment_image_src($term_array['mmckid_image_id'], 'full');
				$term_array['mmckid_image_src_full'] = $img_atts_array[0];
				
				
				$mmckid_point_closed = get_term_meta ( $array['term_id'], 'mmckid_point_closed', true );
				//if($mmckid_point_closed !="yes"){$mmckid_point_closed = 'no';}
				//only add if point is not closed
				if($mmckid_point_closed !="yes"){
					$terms_new_array[]= $term_array;
				}
			}
		
		?>	
			<!--script type="text/javascript" src="//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js"></script-->
			<!--link rel="stylesheet" href="//code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css"-->
			<!--script src="https://code.jquery.com/jquery-1.12.4.js"></script-->
			<!--script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script-->
			<!--script src="https://cdn.jsdelivr.net/npm/selectable.js@latest/selectable.min.js"></script-->
			
			<link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.13.0/css/all.css">

			<link href="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" rel="stylesheet">
			<!--link href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.css" rel="stylesheet"-->
			<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/knockout/3.1.0/knockout-min.js"></script>
			<script type="text/javascript" src="https://rawgit.com/adrotec/knockout-file-bindings/master/knockout-file-bindings.js"></script>
			<script>
				<?php 
					$user_info = get_userdata(get_current_user_id());
					$first_name = $user_info->first_name;
					$last_name = $user_info->last_name;
				
					$admin_ajax_url =  admin_url( 'admin-ajax.php' );
					echo "mmckid_admin_ajax_url = '".$admin_ajax_url."';";
					echo "mmckid_this_site_url = '".get_site_url()."';";//http://www.example.com
					//ایجاد کوکی برای ویریفای شخص حاضر در جاوا اسکریپت
					$mmckid_authentication = array('nonce' => wp_create_nonce('wp_rest'));
					?>var mmckid_authentication = <?php echo json_encode($mmckid_authentication) ?>;<?php
					?>var mmckid_terms = <?php echo json_encode($terms_new_array) ?>;<?php
					
					?>var mmckid_sucsess_image_url = <?php echo '`'.mmckid_url.'assets/green-check.jpg'.'`'; ?>;<?php
					
					
					?>var g_first_name = <?php echo "'".$first_name."'" ?>;<?php
					?>var g_last_name = <?php echo "'".$last_name."'" ?>;<?php

				?>
				
				
(function($, undefined) {
	$(document).ready(function(){

		var current_fs, next_fs, previous_fs; //fieldsets
		var opacity;
		
		<?php  if (isset($_GET['is_callback']) and $_GET['is_callback']== 'yes'){ ?>
			var current = 5;
			$("#progressbar li").addClass("active");
		<?php }else { ?>
			var current = 1;
		<?php } ?>
		
		var steps = $("fieldset").length;

		setProgressBar(current);

		$(".next").click(function(){
			if (!mmckid_validateForm(this)) return false;
			current_fs = $(this).parent();
			next_fs = $(this).parent().next();

			//Add Class Active
			$("#progressbar li").eq($("fieldset").index(next_fs)).addClass("active");
			//show the next fieldset
			next_fs.show();
			//hide the current fieldset with style
			current_fs.animate({opacity: 0}, {
				step: function(now) {
				// for making fielset appear animation
				opacity = 1 - now;

				current_fs.css({
				'display': 'none',
				'position': 'relative'
				});
				next_fs.css({'opacity': opacity});
				},
				duration: 500
			});
			setProgressBar(++current);
		});

		$(".previous").click(function(){
			
			
			if ( $(this).is("#mmckid_back_from_cart") ) {
				if (confirm('آیا می خواهید سبد خرید خالی شود؟')) {
					jQuery("input#mmckid_show_cart_info").val('');
					jQuery("input#mmckid_show_cart_info").hide();
					jQuery("#mmckid_next_in_product_holder").hide();
				} else {
				  return false;
				}
			}
			
			current_fs = $(this).parent();
			previous_fs = $(this).parent().prev();

			//Remove class active
			$("#progressbar li").eq($("fieldset").index(current_fs)).removeClass("active");

			//show the previous fieldset
			previous_fs.show();

			//hide the current fieldset with style
			current_fs.animate({opacity: 0}, {
				step: function(now) {
					// for making fielset appear animation
					opacity = 1 - now;

					current_fs.css({
					'display': 'none',
					'position': 'relative'
					});
					previous_fs.css({'opacity': opacity});
				},
				duration: 500
			});
			setProgressBar(--current);
		});

		function setProgressBar(curStep){
			var percent = parseFloat(100 / steps) * curStep;
			percent = percent.toFixed();
			$(".progress-bar")
			.css("width",percent+"%")
		}

		$(".submit").click(function(){
			return false;
		})

	});
})(jQuery);

				
jQuery(document).ready( function () {
	let x;
	let mmckid_html = "";
	for (x of mmckid_terms){
		
		
		var start =  x.start;//'21:00' for example
		var end = x.end;
		var now = x.now;
		
		currentDate = new Date()   
		
		startDate = new Date(currentDate.getTime());
		startDate.setHours(start.split(":")[0]);
		startDate.setMinutes(start.split(":")[1]);
		//startDate.setSeconds(start.split(":")[2]);

		endDate = new Date(currentDate.getTime());
		endDate.setHours(end.split(":")[0]);
		endDate.setMinutes(end.split(":")[1]);
		//endDate.setSeconds(end.split(":")[2]);
		
		nowDate = new Date(currentDate.getTime());
		nowDate.setHours(now.split(":")[0]);
		nowDate.setMinutes(now.split(":")[1]);
		
		var valid = startDate < nowDate && endDate > nowDate;
		console.log(valid);
		
		var css = '';
		var el_class = ''
		if(!valid){
			css +="opacity: 0.5;cursor: not-allowed;";
			el_class +=" disabled_points ";
		}
		
		mmckid_html +="<div style='" + css + "' class='mmckid_point_item_row  media border p-1  " + el_class + "' data-now='" + x.now + "' data-start='" + x.start + "' data-end='" + x.end + "' data-count='" + x.count + "'  data-mmckid_lat_lng='" + x.mmckid_lat_lng + "' data-mmckid_point_id='" + x.mmckid_point_id + "' data-mmckid_point_kilometer='" + x.mmckid_point_kilometer + "' data-term_id='" + x.term_id + "' > ";
		mmckid_html +=" <img  class=' rounded' src='" + x.mmckid_image_src_full + "' style='width:100px;'>";
		mmckid_html +="<div class='media-body'>";
		mmckid_html +=" <h4 class='mmckid_point_title p-3' style='text-align:right;' >" + x.name + " ";
		if(!valid){
			mmckid_html +=" <small style='color:red;'>تعطیل - ساعات کاری بین "+ x.start +" تا "+ x.end +" </small>";
		}
		mmckid_html +="</h4>";
		mmckid_html +="</div>";
		mmckid_html +="</div>";
	}
	jQuery("#mmckid_points_holder").html(mmckid_html);
	jQuery("div#mmckid_main_inner ").on("click", ".mmckid_point_item_row", function(e) {
		mmckid_on_click_on_points(e);
	});
	jQuery("div#mmckid_main_inner ").on("click", "#mmckid_next_in_product_holder", function(e) {
		mmckid_on_click_on_calculate_cart(e);
	});
	
	jQuery("div#mmckid_main_inner ").on("click", "#mmckid_pay_button", function(e) {
		mmckid_on_click_on_pay(e);
	});
	
	//mmckid_back_from_cart
	jQuery("div#mmckid_main_inner ").on("click", "#mmckid_back_from_cart", function(e) {
		
	});
	
	
	//const selectable = new Selectable({
	   //filter: document.querySelectorAll(".mmckid_point_item_row")
	 //  filter: ".mmckid_point_item_row"
	//});
	//console.log(mmckid_html);
	//var selectable = new Selectable();
	//var items = document.querySelectorAll(".mmckid_point_item_row");

	//selectable.add(items);
	//console.log(items);
	
} );


jQuery(document).ready( function () {
	

} );
				

function mmckid_on_click_on_points(e) {
	
 	if (jQuery(e.currentTarget).hasClass("disabled_points")) {
	  return;
	}
	
	
	jQuery("#mmckid_product_holder").html('');
	jQuery('.mmckid_loading').show();
	jQuery('#mmckid_row_next_2').trigger( 'click' );
	
	
	var term_id = jQuery(e.currentTarget).attr('data-term_id');
	var dist_meter = jQuery(e.currentTarget).attr('data-dist_meter');
	var hazine_ersal = jQuery(e.currentTarget).attr('data-hazine_ersal');
	//var post_type = jQuery('#select_post_type option:selected').val();
	//var search_item = jQuery('#search_item').val();
	//console.log(post_type);
    jQuery.ajax({
        type: "POST",
		url: mmckid_admin_ajax_url,
		data: {
			action: 'mmckid_ajax',
			'ajax_type': 'get_search_results',
			'term_id' : term_id,
			'lat_lng' : jQuery("#lat-lng").val(),//lat-lng
			dist_meter :dist_meter,
			hazine_ersal :hazine_ersal,
		},
        beforeSend: function() {
            
        }, 
		error: function(request, status, error) {
			jQuery('.mmckid_loading').hide();
			console.log(request);
			console.log(status);
			console.log(error);
		},
        success: function(data) {
			jQuery('.mmckid_loading').hide();
			var data_obj = JSON.parse(data);
			//console.log(data_obj.has_post);
			if(data_obj.has_post== "yes"){
				let x;
				let mmckid_html = "";
				for (x of data_obj.data){
					//mmckid_html +="<div class='media border p-1'>";
					mmckid_html +="<div class='mmckid_product_item_row  media border p-1'  data-term_id='" + x.term_id + "' data-stock='" + x.stock + "'  >" ;
					mmckid_html +=" <img  class=' rounded' src='" + x.image_src_thumbnail + "' style='width:100px;'>";
					mmckid_html +="<div class='media-body'>";
					mmckid_html +=" <h4 class='mmckid_point_title p-3' style='text-align:right;margin-bottom:0px;padding-bottom:0px' >" + x.title + "</h4>";
					mmckid_html +=" <div class='mmckid_point_title p-3' style='text-align:right;' ><span>" + x.price.toLocaleString() + "</span>";
					////////////
					mmckid_html += '<div class="qtydiv">';
					//mmckid_html += '<label for="Quantity" class="quantity-selector">تعداد</label>';
					if(x.stock >0){
						mmckid_html += '<div class="qtybox">';
						mmckid_html += '<span class="btnqty qtyminus icon icon-minus">-</span>';
						mmckid_html += '<input type="text" id="quantity" name="quantity" value="0" min="0" data-title="' + x.title + '" data-hazine_ersal="' + x.hazine_ersal + '" data-dist_meter="' + x.dist_meter + '" data-post_id="' + x.post_id + '"  data-term_id="' + x.term_id + '"  data-src_thumbnail="' + x.image_src_thumbnail + '" data-price="' + x.price + '"  data-stock="' + x.stock + '" max="'+ x.stock + '" class="quantity-selector quantity-input" readonly="">';
						mmckid_html += '<span class="btnqty qtyplus icon icon-plus">+</span>';
						mmckid_html += '</div>';
					}else{
						mmckid_html += '<div class="end_stock" style="float:left;color: red;">اتمام موجودی</div>';
					}
					mmckid_html += '</div>';
					////////////
					mmckid_html += '</div>';
					if(0){
						mmckid_html +=" <small style='color:red;'> </small>";
					}
					mmckid_html +="</div>";
					mmckid_html +="</div>";
				}
				jQuery("#mmckid_product_holder").html(mmckid_html);
				
				
				
				//عملکرد دکمه کاهش و افزایش
				jQuery('.qtybox ').on('click','.btnqty', function(){
				  var qty = parseInt(jQuery(this).parent('.qtybox').find('.quantity-input').val());
				  if(jQuery(this).hasClass('qtyplus')) {
					 var stock =  jQuery(this).parent('.qtybox').find('.quantity-input').attr('data-stock');
					 if(qty < Number(stock)){
						qty++;
					 }
				  }else {
					if(qty > 0) {
					  qty--;
					}
				  }
				  qty = (isNaN(qty))?1:qty;
				  jQuery(this).parent('.qtybox').find('.quantity-input').val(qty);
				  
				  
				  var cart_object = {all_price :0 ,all_item_count :0};
				  jQuery('div#mmckid_product_holder .quantity-input').each(function(){
					// use $(this) to reference the current div in the loop
					//console.log(jQuery(this));
					var this_pruduct_count = Number(jQuery(this).val());
					var this_pruduct_price = Number(jQuery(this).attr('data-price'));
					var this_item_all_price = this_pruduct_count * this_pruduct_price ;
					cart_object.all_price += this_item_all_price;
					cart_object.all_item_count += this_pruduct_count;

				   });
				   //input#mmckid_show_cart_info
					var text = '' + cart_object.all_item_count + ' ';
					text += 'مورد به مبلغ';
					text += ' ';
					text += cart_object.all_price.toLocaleString();
					text += ' ';
					text += 'تومان';
					 jQuery("input#mmckid_show_cart_info").val(text);
					 jQuery("input#mmckid_show_cart_info").show();
					 if(cart_object.all_item_count  > 0 ){
						 jQuery("#mmckid_next_in_product_holder").show();
					 }else{
						 jQuery("#mmckid_next_in_product_holder").hide();
					 }
					
				  
				}); 
				
				
				
				
				
				
			}
			//console.log(data_obj);
        }
    });
}
function mmckid_on_click_on_calculate_cart(e) {
	
	var cart_object = {
		all_price :0 ,
		all_item_count :0,
		items : [],
		address : jQuery("#mmckid_form_address_id").val(),
		lat_lng : jQuery("#lat-lng").val()//lat-lng
		
	};
	jQuery('div#mmckid_product_holder .quantity-input').each(function(){
		//console.log(jQuery(this));
		var this_pruduct_count = Number(jQuery(this).val());
		var this_pruduct_price = Number(jQuery(this).attr('data-price'));
		var this_pruduct_post_id = Number(jQuery(this).attr('data-post_id'));
		var this_pruduct_term_id = Number(jQuery(this).attr('data-term_id'));
		var this_pruduct_src_thumbnail = jQuery(this).attr('data-src_thumbnail');
		var this_pruduct_stock = Number(jQuery(this).attr('data-stock'));
		var this_pruduct_title = jQuery(this).attr('data-title');
		var this_pruduct_dist_meter = Number(jQuery(this).attr('data-dist_meter'));
		var this_pruduct_hazine_ersal = Number(jQuery(this).attr('data-hazine_ersal'));
		
		var this_item = {
			count : this_pruduct_count,
			price : this_pruduct_price,
			term_id : this_pruduct_term_id ,
			image_src_thumbnail : this_pruduct_src_thumbnail,
			stock :this_pruduct_stock,
			title : this_pruduct_title,
			post_id :this_pruduct_post_id,
			dist_meter :this_pruduct_dist_meter,
			hazine_ersal :this_pruduct_hazine_ersal,
		};
		var this_item_all_price = this_pruduct_count * this_pruduct_price ;
		cart_object.all_price += this_item_all_price;
		cart_object.all_item_count += this_pruduct_count;
		if (this_pruduct_count > 0 ){
			cart_object.items[cart_object.items.length] = this_item;
		}
		

	});
	cart_object.all_price += Number(jQuery('div#mmckid_product_holder .quantity-input:first').attr('data-hazine_ersal'));
	cart_object.hazine_ersal = Number(jQuery('div#mmckid_product_holder .quantity-input:first').attr('data-hazine_ersal'));
	console.log(cart_object);
	jQuery("#mmckid_show_factor").html('');
	var mmckid_html ="";
	mmckid_html +='<div class="container">';
	mmckid_html +='<div class="row border-bottom p-1" style="max-width: 100%;">';
	mmckid_html +='<div class="col-6">';
	mmckid_html +='<span class="">نام و نام خانوادگی : </span>';
	mmckid_html +='</div>';
	mmckid_html +='<div class="col-6">';
	mmckid_html +='<span class="">' + g_first_name +' '+ g_last_name + '</span>';
	mmckid_html +='</div>';
	mmckid_html +='</div>';
	
	mmckid_html +='<div class="row border-bottom p-1" style="max-width: 100%;">';
	mmckid_html +='<div class="col-6">';
	mmckid_html +='<span class="">آدرس : </span>';
	mmckid_html +='</div>';
	mmckid_html +='<div class="col-6">';
	mmckid_html +='<span class="">' + jQuery("#mmckid_form_address_id").val() + '</span>';
	mmckid_html +='</div>';
	mmckid_html +='</div>';
	
	mmckid_html +='<div class="row p-1" style="max-width: 100%;">';
	mmckid_html +='<div class="col-6">';
	mmckid_html +='<span class="">هزینه ارسال : </span>';
	mmckid_html +='</div>';
	mmckid_html +='<div class="col-6">';
	mmckid_html +='<span class="" style="color:green; display: inline-block;float: left;">' + cart_object.items[0].hazine_ersal + ' تومان</span>';
	mmckid_html +='</div>';
	mmckid_html +='</div>';
	mmckid_html +='</div>';
	
	
	
	for (x of cart_object.items){
		console.log(x);
		//mmckid_html +="<div class='media border p-1'>";
		mmckid_html +="<div class='mmckid_product_item_row  media border p-1' >" ;
		mmckid_html +="<div class='media-body'>";
		mmckid_html +=" <h4 class='mmckid_point_title p-3' style='text-align:right;margin-bottom:0px;padding-bottom:0px' >" + x.title +" " + x.count + " عدد <span style='color:green; display: inline-block;float: left;' >قیمت واحد " + x.price.toLocaleString() + " تومان</span></h4>";
		mmckid_html +="</div>";
		mmckid_html +="</div>";
	}
	
	mmckid_html +='<div class="container">';
	mmckid_html +='<div class="row p-1 border-bottom" style="max-width: 100%;">';
	mmckid_html +='<div class="col-6">';
	mmckid_html +='<span class="">جمع کل : </span>';
	mmckid_html +='</div>';
	mmckid_html +='<div class="col-6">';
	mmckid_html +='<span class="">' + cart_object.all_price.toLocaleString() + ' تومان</span>';
	mmckid_html +='</div>';
	mmckid_html +='</div>';
	mmckid_html +='</div>';
	
	
	jQuery("#mmckid_show_factor").html(mmckid_html);
	
	//mmckid_show_factor
	mmckid_cart_object = cart_object;
	let a = new Date(Date.now() + 36e5);
	setWithExpiry("mmckid_cart_object", cart_object, a);
	//mmckid_cart_object = getWithExpiry("mmckid_cart_object");
}



function mmckid_on_click_on_pay(e) {
	
	jQuery("#mmckid_show_thank_you").html('');
	var mmckid_html ="";
	
	
	
	jQuery('.mmckid_loading').show();

    jQuery.ajax({
        type: "POST",
		url: mmckid_admin_ajax_url,
		data: {
			action: 'mmckid_ajax',
			'ajax_type': 'pay_order',
			'cart_object' : mmckid_cart_object,
		},
        beforeSend: function() {
            
        }, 
		error: function(request, status, error) {
			jQuery('.mmckid_loading').hide();
			console.log(request);
			console.log(status);
			console.log(error);
		},
        success: function(data) {
			jQuery('.mmckid_loading').hide();
			var data_obj = JSON.parse(data);
			console.log(data_obj);
			//$data_return = array( 'status' => $status, 'order_id'=> $order_id , 'redirect_to_bank' => $redirect_to_bank);
			if(data_obj.bank.status == '0' ){
				 window.location.href = data_obj.bank.redirect_to_bank;
			}
			if(data_obj.sucsess == "yes"){
				mmckid_html +='<div class="row">';
				mmckid_html +='	<div class="col-12 to_hide">';
				mmckid_html +='		<h2 class="fs-title">پایان</h2>';
				mmckid_html +='	</div>';
				mmckid_html +='</div>';
				mmckid_html +='<div class="row justify-content-center">';
				mmckid_html +='	<div class="col-3"> <img src="'+ mmckid_sucsess_image_url +'" class="fit-image"> </div>';
				mmckid_html +='</div> <br><br>';
				mmckid_html +='<div class="row justify-content-center">';
				mmckid_html +='	<div class="col-7 text-center">';
				mmckid_html +='		<h5 class="purple-text text-center">پرداخت شما با موفقیت انجام شد</h5>';
				mmckid_html +='	</div>';
				mmckid_html +='	<div class="col-7 text-center mmckid_t_enter">';
				mmckid_html +='		<label class="fieldlabels">سفارش شما</label>';
				mmckid_html +='		<span  id="mmckid_form_user_name" >'+ data_obj.order_id +'</span>';
				mmckid_html +='	</div>';
				mmckid_html +='	<div class="col-7 text-center mmckid_t_enter">';
				mmckid_html +='		<label class="fieldlabels"></label>';
				mmckid_html +='		<span  id="mmckid_form_user_pass" >'+ data_obj.point_name +'</span>';
				mmckid_html +='	</div>';
				mmckid_html +='	<div class="col-7 text-center mmckid_t_enter">';
				mmckid_html +='		<label class="fieldlabels">زمان تحویل</label>';
				mmckid_html +='		<span  id="mmckid_form_email_finish" ></span>';
				mmckid_html +='	</div>';
				mmckid_html +='	<div class="col-7 text-center mmckid_t_enter">';
				mmckid_html +='		<label class="fieldlabels">تماس با ما</label>';
				mmckid_html +='		<span  id="mmckid_form_mobile_finish" ></span>';
				mmckid_html +='	</div>';
				mmckid_html +='</div>';
				jQuery("#mmckid_show_thank_you").html('<h2 class="fs-title">اتصال به بانک .....</h2>');
				

			}
			//console.log(data_obj);
        }
    });
	
	
	


}

//set from localStorage
function setWithExpiry(n, t, i) {
    const r = {
        value: t,
        expiry: i
    };
    localStorage.setItem(n, JSON.stringify(r))
}
//get from localStorage
function getWithExpiry(n) {
    const t = localStorage.getItem(n);
    if (!t) return null;
    const i = JSON.parse(t);
    let r = new Date(Date.now());
    var u = new Date(i.expiry);
    return r > u ? (localStorage.removeItem(n), null) : i.value
}



				
				
			</script>
			<style>
				/*
				#msform fieldset:not(:first-of-type) {
					display: none
				}
				*/
				#msform fieldset {
					display: none
				}
			
				div#mmckid_show_thank_you {
					padding-top: 10px;
				}
			
				.position-relative.ft-arrow {
					display: none;
				}
				.mmckid_point_item_row {
					cursor: pointer;
				}
				.mmckid_loading.spinner-border.text-primary {
					width: 27px;
					height: 27px;
					border-width: 3px;
					margin-right: 5px;
					line-height: 2;
					vertical-align: middle;
					margin: auto;
					margin-top: 100px;
					margin-bottom: 100px;
					float:none;
				}
				input#mmckid_row_next_2 {
					cursor: not-allowed !important;
					background-color: #fa640052 !important;
				}
				.qtydiv label{display: block;margin-bottom: 12px;letter-spacing: 2.8px;color: #747a7b;}
				.qtydiv .btnqty{display: inline-block;cursor: pointer;user-select: none;font-size: 25px;padding: 5px;}
				.qtydiv .btnqty.qtyminus{margin-right: 8px;}
				.qtydiv .btnqty.qtyplus{margin-left: 8px;}
				.qtydiv .quantity-input{border: none;border: none;padding: 8px;text-align: center;width: 50px;outline: none;display: inline-block;}
				.qtydiv {display: inline-block;padding-right: 15px;padding-top: 10px;}
				div#mmckid_main_wrapper input#quantity {
					width: 52px;
					padding: 0;
					margin: 0;
					font-weight: bold;
				}
				div#mmckid_main_wrapper .qtydiv .btnqty.qtyplus {
					margin-left: 0;
					vertical-align: middle;
					font-size: 24px;
					font-weight: bold;
					padding: 0px 11px;
					background-color: green;
					color: white;
					line-height: 26px;
				}
				
				div#mmckid_main_wrapper .qtydiv .btnqty.qtyminus{
					margin-left: 0;
					vertical-align: middle;
					font-size: 24px;
					font-weight: bold;
					padding: 0px 11px;
					background-color: red;
					color: white;
					line-height: 26px;
				}
				div#mmckid_main_wrapper .qtydiv {
					float: left;
				}
				#progressbar #vendor_shop:before {
					/*font-family: "fas";*/
					font-family: 'Font Awesome 5 Free';
					content: '\f54e';

				}
				#progressbar i:before {
					width: 50px;
					height: 50px;
					line-height: 45px;
					display: block;
					font-size: 20px;
					color: #ffffff;
					background: lightgray;
					border-radius: 50%;
					margin: 0 auto 10px auto;
					padding: 2px;
				}
				div#mmckid_main_wrapper .fas {
					font-family: "Font Awesome 5 Free";
				}
				div#mmckid_main_wrapper li.fas:before {
					font-family: 'Font Awesome 5 Free';
				}
				div#mmckid_main_wrapper #mmckid_show_cart_info {
					width: auto ;
					background: green;
					font-weight: bold;
					color: white;
					border: 0 none;
					border-radius: 0px;
					cursor: pointer;
					padding: 10px 12px;
					margin: 10px 0px 10px 0px;
					float: left;
				}
										
			</style>
			<script type="text/javascript" src="<?php echo mmckid_url.'leaflet/leaflet.js'; ?>"></script>
			<script type="text/javascript" src="<?php echo mmckid_url.'assets/front.js?v='.mmckid_version; ?>"></script>
			<link href="<?php echo mmckid_url.'assets/front.css?v='.mmckid_version; ?>" rel="stylesheet">
			<link href="<?php echo mmckid_url.'leaflet/leaflet.css' ?>" rel="stylesheet">
			<div id="mmckid_main_wrapper">
				<div id="mmckid_main_inner">
				<?php
				
				//echo '<div style="direction:ltr;padding:40px;">'. highlight_string(var_export($_REQUEST, true) ) .'</div>';
				
				//echo '<div style="direction:ltr;padding:40px;">'. highlight_string(var_export($_GET, true) ) .'</div>';
				
				//echo '<div style="direction:ltr;padding:40px;">'. highlight_string(var_export($_POST, true) ) .'</div>';
				
				if(isset($_GET['is_callback'])){
				
				//$order_id	= $_GET['order_id'];
				//$mmckid_data_sent_to_miare = get_post_meta ( $order_id, 'mmckid_data_sent_to_miare', true );
				//$mmckid_data_recived_from_miare = get_post_meta ( $order_id, 'mmckid_data_recived_from_miare', true );
				//echo '<div style="direction:ltr;padding:40px;float: left;text-align: left;">'. highlight_string(var_export($mmckid_data_sent_to_miare, true) ) .'</div>';
				//echo '<div style="direction:ltr;padding:40px;float: left;text-align: left;">'. highlight_string(var_export($mmckid_data_recived_from_miare, true) ) .'</div>';
				
				
				}
				?>
				
				
				
				
				
					<div class="container-fluid">
						<div class="row justify-content-center">
							<div class="col-11 col-sm-10 col-md-10 col-lg-6 col-xl-5 text-center p-0 mt-3 mb-2">
								<div class="card px-0 pt-4 pb-0 mt-3 mb-3">
									<form id="msform">
										<!-- progressbar -->
										<ul id="progressbar"> 
											<li class="active fas fa-compass" ><strong>انتخاب محل تحویل</strong></li>
											<li class="fas fa-store"><strong>مشاهده شعبه ها</strong></li>
											<li id="vendor_product"><strong>مشاهده محصولات</strong></li>
											<li id="credit_card"><strong> پرداخت </strong></li>
											<li id="confirm"><strong>پایان</strong></li>
										</ul>
										<div class="progress">
											<div class="progress-bar progress-bar-striped progress-bar-animated" role="progressbar" aria-valuemin="0" aria-valuemax="100"></div>
										</div> <br> <!-- fieldsets -->
										<fieldset style="<?php  if (isset($_GET['is_callback']) and $_GET['is_callback']== 'yes'){}else{ echo 'display:block;';}?>">
											<div class="form-card">
												<div class="row">
													<div class="col-12 to_hide">
														<h2 class="fs-title"> انتخاب محل تحویل</h2>
													</div>
												</div>
												<label class="fieldlabels">آدرس *</label>
												<input type="text" id="mmckid_form_address_id" name="mmckid_form_address" placeholder="آدرس" />
												<input type="text" id="lat-lng" name="lat-lng" style="display: none;">
												<div id="map" style="height: 300px;width: 100%;"></div>
												<!--textarea id="txt_address" placeholder="آدرس دقیق" rows="2" cols="20"></textarea-->
												
											</div> 
											<input type="button" name="next" class="next action-button" value="بعدی" />
										</fieldset>
										<fieldset>
											<div class="form-card">
												<div class="row">
													<div class="col-12 to_hide">
														<h2 class="fs-title"> مشاهده شعبه ها </h2>
													</div>
												</div> 
												<div class="row">
													<div class="col-12">
													<div id="mmckid_points_holder" style="max-height: 300px;overflow: auto;"></div>
													</div>
													<div id="mmckid_points_holder_empty_message" style="display:none;padding: 10px;">
														<h3 style="text-align: center;">شعبه ای یافت نشد</h3>
														<p style="text-align: center;">متاسفانه در محدوده شما شعبه ای نداریم، شما میتوانید از منو محصولات سفارش خود را ثبت کنید</p>
														<div style="text-align: center;"><a href="<?php echo home_url().'/shop'; ?>" style="text-decoration:none;">مشاهده همه محصولات &gt;&gt;</a></div>
													</div>
												</div>
											</div> 
											<input type="button" name="next" id="mmckid_row_next_2" class="next action-button disabled " value="بعدی" style="display:none;"> 
											<input type="button" name="previous" class="previous action-button-previous" value="قبلی" />
										</fieldset>
										<fieldset>
											<div class="form-card">
												<div class="row">
													<div class="col-12 to_hide">
														<h2 class="fs-title"> مشاهده محصولات موجود</h2>
													</div>
												</div>
												<div class="row">
													 <div style="display:none;" class="mmckid_loading spinner-border text-primary"></div>
													<div id="mmckid_product_holder"  class="col-12 mmckid_row_id_froshgah" style="max-height: 300px;overflow: auto;">
														
													</div>
												</div>
											</div> 
											<input type="button"  id="mmckid_next_in_product_holder"  name="next" class="next action-button" value="بعدی" style="display:none;"> 
											<input type="button" id="mmckid_back_from_cart" name="previous" class="previous action-button-previous" value="قبلی" /> 
											<input type="button" id="mmckid_show_cart_info" class="" value="سبد خرید" style="display:none;">
										</fieldset>
										<fieldset>
											<div class="form-card">
												<div class="row">
													<div class="col-12 to_hide">
														<h2 class="fs-title">پرداخت</h2>
													</div>
												</div>
												<div class="row">
													<div class="col-12">
														<div id="mmckid_show_factor"  style="max-height: 400px;overflow: auto;">
															
														</div>
													</div>
												</div>												
											</div>
											<input type="button" id="mmckid_pay_button" style="" name="" class="next action-button" value="پرداخت" >
											<input type="button" id="mmckid_last_previous_button" name="previous" class="previous action-button-previous" value="قبلی" >
											
											<input id='mmckid_last_next' style="display:none;"  type="button" name="next" class="next action-button" value="بعدی" > 
										</fieldset>
										<fieldset style="<?php  if (isset($_GET['is_callback']) and $_GET['is_callback']== 'yes'){ echo 'display:block;';}?>">
											<div class="form-card" id="mmckid_thank_you_page">
												<div style="display:none;float: none;" class="mmckid_loading spinner-border text-primary"></div>
												<div id="mmckid_show_thank_you">
													<?php  if (isset($_GET['is_callback']) and $_GET['is_callback']== 'yes'){ ?>
													
													<?php 
													
													//array('status'=>'no','html_error'=>$html_error,'error_code'=>$error_code);
													//array('status'=>'yes','Token'=> $Token,'OrderId'=> $OrderId,'RRN'=> $RRN);
													
													?>
														<?php if($callback_result['status']=='yes'){  ?>
															<div class="row">
																<div class="col-12 to_hide">
																	<h2 class="fs-title">پایان</h2>
																</div>
															</div>
															<div class="row justify-content-center">
																<div class="col-3"><img src="<?php echo mmckid_url.'assets/green-check.jpg'; ?>" class="fit-image"></div>
															</div> <br><br>
															<div class="row justify-content-center">
																<div class="col-7 text-center">
																	<h5 class="purple-text text-center">پرداخت شما با موفقیت انجام شد</h5>
																</div>
																<div class="col-7 text-center mmckid_t_enter">
																	<label class="fieldlabels">شماره پیگیری</label>
																	<span><?php echo $callback_result['Token']; ?></span>
																</div>
																<div class="col-7 text-center mmckid_t_enter">
																	<label class="fieldlabels">شماره سفارش</label>
																	<span  id="mmckid_form_user_name"><?php echo $_GET['order_id']; ?></span>
																</div>
																<div class="col-7 text-center mmckid_t_enter">
																	<label class="fieldlabels">زمان تحویل</label>
																	<span  id="mmckid_form_email_finish" > یک تا دو ساعت </span>
																</div>
																<div class="col-7 text-center mmckid_t_enter">
																		<label class="fieldlabels">تماس با ما</label>
																	<span  id="mmckid_form_mobile_finish" > 021-91070256 </span>
																</div>
															</div>
														<?php }else{ ?>
															<?php echo $callback_result['html_error']; ?>
														<?php } ?>
													<?php } ?>
												
												</div>
											</div>
										</fieldset>
									</form>
								</div>
							</div>
						</div>
					</div>
				</div>	
			</div>	
		<?php
		}
		public static function add_settings_link( $links, $file ) {
			//$settings = self::get_settings();
			if ( current_user_can( 'manage_options' ) ) {
				$url = admin_url( '?page=mmckid' );
				$links = (array) $links;
				$links[] = sprintf( '<a href="%s">%s</a>', $url, __( 'Settings', 'mmckid' ) );
			}
			return $links;
		}
		public static function activate() {
			if (! wp_next_scheduled ( 'scheduled_mmckid_set_1' )) {
				//$settings = self::get_settings();
				//wp_schedule_event(time(), $settings['ip_send_report_period'], 'scheduled_mmckid_set_1');
			}
			$settings = array(
				'ip_send_email_to' => get_option( 'ip_send_email_to',get_option( 'admin_email' ) ),
			);
			add_option( 'mmckid_settings', $settings );
		}
		public static function deactivat() {
		}
		public static function uninstall() {
			delete_option( 'mmckid_settings' );
		}
		public static function mmckid_options_updated($old_value, $value ) {
			if($old_value['ip_send_report_period'] !== $value['ip_send_report_period']){
			}
		}
		public static function receipt_page($order_id) {

            global $woocommerce;
            $order = new WC_Order($order_id);
			$currency = $order->get_order_currency();
			$amount = intval($order->order_total);
			if ( strtolower($currency) == strtolower('IRT') || strtolower($currency) == strtolower('TOMAN')
				|| strtolower($currency) == strtolower('Iran TOMAN') || strtolower($currency) == strtolower('Iranian TOMAN')
				|| strtolower($currency) == strtolower('Iran-TOMAN') || strtolower($currency) == strtolower('Iranian-TOMAN')
				|| strtolower($currency) == strtolower('Iran_TOMAN') || strtolower($currency) == strtolower('Iranian_TOMAN')
				|| strtolower($currency) == strtolower('تومان') || strtolower($currency) == strtolower('تومان ایران')
			)
				$amount = $amount*10;
			else if ( strtolower($currency) == strtolower('IRHT') )							
				$amount = $amount*1000*10;
			else if ( strtolower($currency) == strtolower('IRHR') )							
				$amount = $amount*1000;
			
			
			$redirect_to_bank ="";
			if($order_id > 0)
			{
				$LoginAccount	= "gGU0Kexx65iUenjUNT6Y2";
				$CallBackUrl	= get_site_url()."/instant-delivery/" . "?order_id=" . $order_id . "&is_callback=yes";
				$order_id		= $order_id.mt_rand(10,100);
				$Request = self::PecPayRequest($LoginAccount,$amount,$order_id,$CallBackUrl);
				if($Request->Status == '0' && $Request->Token > 0){
					$status = $Request->Status;
					$redirect_to_bank ='https://pec.shaparak.ir/NewIPG/?Token='.$Request->Token;
					
					
				}
				else{
					$status = $Request->Status;
				}
			}
			else{
				$status = 'error_creating_order';
			}
			//$html_error = self::display_error($error_code,'',$order_id,0);
			$to_return = array( 'status' => $status, 'order_id'=> $order_id , 'redirect_to_bank' => $redirect_to_bank);
            return $to_return;
        }
		public static function callback() {
			
            global $woocommerce;
			$order_id	= isset($_GET['order_id']) ? $_GET['order_id'] : '';
			$Token		= isset($_REQUEST['Token']) ? $_REQUEST['Token'] : '';
			$status		= isset($_REQUEST['status']) ? $_REQUEST['status'] : '';
			$OrderId	= isset($_REQUEST['OrderId']) ? $_REQUEST['OrderId'] : '';
			$TerminalNo	= isset($_REQUEST['TerminalNo']) ? $_REQUEST['TerminalNo'] : '';
			$RRN		= isset($_REQUEST['RRN']) ? $_REQUEST['RRN'] : '';

			if($status == '0' && $Token > 0){
				//if($order_id == substr($OrderId,0,-2)){
					$order = new WC_Order($order_id);
					if(isset($order->id)){
						if($order->post_status == 'wc-completed'){
							$error_code = 'already_been_completed';
						}
						else{
							$LoginAccount = "gGU0Kexx65iUenjUNT6Y2";
							$Request = self::PecVerifyRequest($LoginAccount,$Token);
							if($Request->Status == '0' && $Request->RRN > 0)
							{
								if($order->update_status('completed')){
									$order->payment_complete();
									$order->add_order_note('پرداخت شما با موفقیت با شماره پیگیری '.$Token.' انجام شد.', 1);
									$woocommerce->cart->empty_cart();
									//wp_redirect($this->get_return_url($order));
									//exit();
									return array('status'=>'yes','Token'=> $Token,'OrderId'=> $OrderId,'RRN'=> $RRN);
								}else{
									$reversal_request = self::PecReversalRequest($LoginAccount,$Token);
									if($reversal_request == '0'){
										$error_code = 'reversal_done';
									}
									else{
										$error_code = 'reversal_error';
									}
								}
							}
							elseif($Request->Status == '-1'){
								$error_code = 'retry';
							}
							else{
								$error_code = $Request->Status;
							}
						}
					}
					else{
						$error_code = 'order_not_exist';
					}
				//}else{
				//	$error_code = 'order_not_for_this_person';
				//}
			}
			else{
				$error_code = $status;
			}
			$html_error = self::display_error($error_code,$Token,$order_id);
			return array('status'=>'no','html_error'=>$html_error,'error_code'=>$error_code);
            //exit;
        }
        
		public static function PecPayRequest($LoginAccount,$amount,$order_id,$redirect,$additional='')
		{
			$parameters = array(
				'LoginAccount'		=> $LoginAccount,
				'Amount' 			=> $amount,
				'OrderId' 			=> $order_id,
				'CallBackUrl' 		=> $redirect,
				'AdditionalData' 	=> $additional
			);
			if(extension_loaded('soap')){
				try {
					$client	= new SoapClient('https://pec.shaparak.ir/NewIPGServices/Sale/SaleService.asmx?WSDL',array('soap_version'=>'SOAP_1_1','cache_wsdl'=>WSDL_CACHE_NONE  ,'encoding'=>'UTF-8'));
					$result	= $client->SalePaymentRequest(array("requestData" => $parameters));
					$output = array(
						'Status'	=>	$result->SalePaymentRequestResult->Status,
						'Token'		=>	$result->SalePaymentRequestResult->Token
					);
				}
				catch(Exception $e){
					$output = array('Status' =>	'-1','Token' =>	'');
				}
			}
			else{
				$output = array('Status' =>	'-2','Token' =>	'');
			}
			return (object)$output;
		}
		public static function PecVerifyRequest($LoginAccount,$Token)
		{
			$parameters = array(
				'LoginAccount'		=> $LoginAccount,
				'Token' 			=> $Token
			);
			if(extension_loaded('soap')){
				try {
					$client	= new SoapClient('https://pec.shaparak.ir/NewIPGServices/Confirm/ConfirmService.asmx?WSDL',array('soap_version'=>'SOAP_1_1','cache_wsdl'=>WSDL_CACHE_NONE  ,'encoding'=>'UTF-8'));
					$result	= $client->ConfirmPayment(array("requestData" => $parameters));
					$output['Status'] = $result->ConfirmPaymentResult->Status;
					$output['RRN'] = $result->ConfirmPaymentResult->RRN;
					$output['CardNumberMasked'] = isset($result->ConfirmPaymentResult->CardNumberMasked) ? $result->ConfirmPaymentResult->CardNumberMasked : '';
				}
				catch(Exception $e){
					$output = array('Status' =>	'-1','RRN' => '');
				}
			}
			else{
				$output = array('Status' =>	'-2','RRN' => '');
			}
			return (object)$output;
		}
		public static function PecReversalRequest($LoginAccount,$Token)
		{
			$parameters = array(
				'LoginAccount'		=> $LoginAccount,
				'Token' 			=> $Token
			);
			if(extension_loaded('soap')){
				try {
					$client	= new SoapClient('https://pec.shaparak.ir/NewIPGServices/Reverse/ReversalService.asmx?WSDL',array('soap_version'=>'SOAP_1_1','cache_wsdl'=>WSDL_CACHE_NONE  ,'encoding'=>'UTF-8'));
					$result	= $client->ReversalRequest(array("requestData" => $parameters));
					$output['Status'] = $result->ReversalRequestResult->Status;
					$output['Token'] = $result->ReversalRequestResult->Token;
				}
				catch(Exception $e){
					$output = array('Status' =>	'-1','Token' => '');
				}
			}
			else{
				$output = array('Status' =>	'-2','Token' => '');
			}
			return (object)$output;
			
		}
		public static function display_error($pay_status='',$tran_id='',$order_id='',$is_callback=1)
		{
			$page_html = '<div align="center" dir="rtl" style="font-family:tahoma;font-size:12px;line-height: 25px;color:#000000;margin: -25px 0px -23px 0px;">';
				if($pay_status == 'retry')
				{
					$page_title = 'خطای موقت در پرداخت';
					$admin_mess = 'در هنگام بازگشت خریدار از بانک سرور بانک پاسخ نداد ، از خریدار درخواست شد صفحه را رفرش کند';
					$page_html .= '
						<div style="color: #ff0000;font-weight: bold;font-size: 12px;margin: 25px;">::: خطای موقت :::</div>
						<div style="margin-bottom:21px;font-size: 12px;">
							سرور درگاه اینترنتی <span style="color:#ff0000;">به صورت موقت</span> با مشکل مواجه شده است ، جهت تکمیل تراکنش لحظاتی بعد بر روی دکمه زیر کلیک کنید
						</div>
						<div style="margin:20px 0px 25px 0px;color:#008800;" id="reqreload">
							<button onclick="reload_page()">تلاش مجدد</button>
						</div>
						<script>
							function reload_page(){
								document.getElementById("reqreload").innerHTML = "در حال تلاش مجدد لطفا صبر کنید ..";
								location.reload();
							}
						</script>
					';
				}
				elseif($pay_status == 'reversal_done')
				{
					$page_title = 'مشکل در ارائه خدمات';
					$admin_mess = 'خریدار مبلغ را پرداخت کرد اما در هنگام بازگشت از بانک مشکلی در ارائه خدمات رخ داد ، دستور بازگشت وجه به حساب خریدار در بانک ثبت شد';
					$page_html .= '<span style="color:#ff0000;"><b>مشکل در ارائه خدمات</b></span><br/>';
					$page_html .= '<p style="text-align:center;margin-right:15px;font-size: 12px;margin: 15px 0px 20px 0px;line-height: 25px;">';
					$page_html .= "پرداخت شما با شماره پیگیری $tran_id با موفقیت در بانک انجام شده است اما در ارائه خدمات مشکلی رخ داده است !<br />";
					$page_html .= 'دستور بازگشت وجه به حساب شما در بانک ثبت شده است ، در صورتی که وجه پرداختی تا ساعات آینده به حساب شما بازگشت داده نشد با پشتیبانی تماس بگیرید (نهایت مدت زمان بازگشت به حساب 72 ساعت می باشد)';
					$page_html .= '</p>';
					$page_html .= '<a href="'.get_option('siteurl').'" style="text-decoration:none;">بازگشت به صفحه نخست >></a><br/>';
					
				}
				elseif($pay_status == 'reversal_error')
				{
					$page_title = 'مشکل در ارائه خدمات';
					$admin_mess = 'خریدار مبلغ را پرداخت کرد اما در هنگام بازگشت از بانک مشکلی در ارائه خدمات رخ داد ، ثبت دستور بازگشت وجه به حساب خریدار نیز با خطا روبرو بود ، به این خریدار می بایست یا خدمات ارائه شود و یا مبلغ به حساب بانکی وی عودت داده شود.';
					$page_html .= '<span style="color:#ff0000;"><b>مشکل در ارائه خدمات</b></span><br/>';
					$page_html .= '<p style="text-align:center;margin-right:15px;font-size: 12px;margin: 15px 0px 20px 0px;line-height: 25px;">';
					$page_html .= "پرداخت شما با شماره پیگیری $tran_id با موفقیت در بانک انجام شده است اما در ارائه خدمات مشکلی رخ داده است !<br />";
					$page_html .= 'به منظور ثبت دستور بازگشت وجه به حساب شما در بانک اقدام شد اما متاسفانه با خطا روبرو شد ، لطفا به منظور دریافت خدمات و یا استرداد وجه پرداختی با پشتیبانی تماس بگیرید';
					$page_html .= '</p>';
					$page_html .= '<a href="'.get_option('siteurl').'" style="text-decoration:none;">بازگشت به صفحه نخست >></a><br/>';
					
				}
				elseif($pay_status == 'already_been_completed')
				{
					$page_title = 'سفارش پیش از این موفق شده است';
					$page_html .= '<span style="color:#008800;"><b>سفارش پیش از این موفق شده است</b></span><br/>';
					$page_html .= '<p style="text-align:center;margin-right:15px;font-size: 12px;margin: 15px 0px 20px 0px;line-height: 25px;">';
					$page_html .= "سفارش شما پیش از این با شماره پیگیری $tran_id با موفقیت ثبت شده است";
					$page_html .= '</p>';
					$page_html .= '<a href="'.get_option('siteurl').'" style="text-decoration:none;">بازگشت به صفحه نخست >></a><br/>';
					
				}
				elseif($pay_status == 'order_not_exist')
				{
					$page_title = 'سفارش یافت نشد';
					$admin_mess = 'سفارش در سایت یافت نشد';
					$page_html .= '<span style="color:#ff0000;"><b>سفارش یافت نشد</b></span><br/>';
					$page_html .= '<p style="text-align:center;margin-right:15px;font-size: 12px;margin: 15px 0px 20px 0px;line-height: 25px;">';
					$page_html .= 'متاسفانه سفارش شما در سایت یافت نشد ! در صورتی که وجه پرداختی از حساب بانکی شما کسر شده باشد به صورت خودکار از سوی بانک به حساب شما باز خواهد گشت (نهایت مدت زمان بازگشت به حساب 72 ساعت می باشد)';
					$page_html .= '</p>';
					$page_html .= '<a href="'.get_option('siteurl').'" style="text-decoration:none;">بازگشت به صفحه نخست >></a><br/>';
					
				}
				elseif($pay_status == 'order_not_for_this_person')
				{
					$page_title = 'شماره سفارش نادرست است';
					$admin_mess = 'شماره سفارش نادرست است';
					$page_html .= '<span style="color:#ff0000;"><b>شماره سفارش نادرست است</b></span><br/>';
					$page_html .= '<p style="text-align:center;margin-right:15px;font-size: 12px;margin: 15px 0px 20px 0px;line-height: 25px;">';
					$page_html .= 'شماره سفارش نادرست است ؛ در صورت نیاز به پشتیبانی تماس بگیرید';
					$page_html .= '</p>';
					$page_html .= '<a href="'.get_option('siteurl').'" style="text-decoration:none;">بازگشت به صفحه نخست >></a><br/>';
					
				}
				elseif($pay_status == 'error_creating_order')
				{
					$page_title = 'مشکل در ثبت سفارش';
					$admin_mess = 'مشکل در ثبت سفارش';
					$page_html .= '<span style="color:#ff0000;"><b>مشکل در ثبت سفارش</b></span><br/>';
					$page_html .= '<p style="text-align:center;margin-right:15px;font-size: 12px;margin: 15px 0px 20px 0px;line-height: 25px;">';
					$page_html .= 'مشکلی در ثبت سفارش وجود دارد ، لطفا این موضوع را با پشتیبانی در میان بگذارید';
					$page_html .= '</p>';
					$page_html .= '<a href="'.get_option('siteurl').'" style="text-decoration:none;">بازگشت به صفحه نخست >></a><br/>';
					
				}
				elseif($is_callback == 0)
				{
					$page_title = $admin_mess = 'خطا در ارسال به بانک';
					$page_html .= '<span style="color:#ff0000;"><b>خطا در ارسال به بانک</b></span><br/>';
					$page_html .= '<p style="text-align:center;margin-right:15px;font-size: 12px;margin: 15px 0px 20px 0px;line-height: 25px;">';
					$page_html .= "خطای $pay_status در ارسال به بانک ، ".self::PecStatus($pay_status);
					$page_html .= '</p>';
					$page_html .= '<a href="'.get_option('siteurl').'" style="text-decoration:none;">بازگشت به صفحه نخست >></a><br/>';
					
				}
				else
				{
					$page_title = 'پرداخت انجام نشد';
					$page_html .= '<span style="color:#ff0000;"><b>پرداخت انجام نشد</b></span><br/>';
					$page_html .= '<p style="text-align:center;margin-right:15px;font-size: 12px;margin: 15px 0px 20px 0px;line-height: 25px;">';
					$page_html .= self::PecStatus($pay_status);
					$page_html .= '؛ در صورتی که وجه پرداختی از حساب بانکی شما کسر شده باشد به صورت خودکار از سوی بانک به حساب شما باز خواهد گشت (نهایت مدت زمان بازگشت به حساب 72 ساعت می باشد) - در صورت نیاز با پشتیبانی تماس بگیرید.';
					$page_html .= '</p>';
					$page_html .= '<p style="text-align:center;margin-right:15px;font-size: 12px;margin: 15px 0px 20px 0px;line-height: 25px;">در صورت نیاز با پشتیبانی تماس بگیرید. همچنین شما می توانید با مراجعه به لیست سفارش ها در حساب کاربری، مجددا جهت پرداخت اقدام بفرمایید</p>';
					$page_html .= '<a href="'.home_url("my-account/orders").'" style="text-decoration:none;">بازگشت به سفارشات >></a><br/>';
					$admin_mess = 'پرداخت انجام نشد '.self::PecStatus($pay_status);
					
				}
			$page_html .= '</div>';
				
			if(isset($admin_mess) && $order_id != '' && $pay_status != 'order_not_for_this_person'){
				$order = new WC_Order($order_id);
				$order->add_order_note($admin_mess);
			}
			//wp_die($page_html,$page_title);
			
			return $page_html;
		}
		
		
		public static function PecStatus($code='',$error_page=0){
			
			switch($code){
				case '-32768':
					$response = 'خطای ناشناخته رخ داده است';
					break;
				case '-1552':
					$response = 'برگشت تراکنش مجاز نمی باشد';
					break;
				case '-1551':
					$response = 'برگشت تراکنش قبلاً انجام شده است';
					break;
				case '-1550':
					$response = 'برگشت تراکنش در وضعیت جاری امکان پذیر نمی باشد';
					break;
				case '-1549':
					$response = 'زمان مجاز برای درخواست برگشت تراکنش به اتمام رسیده است';
					break;
				case '-1548':
					$response = 'فراخوانی سرویس درخواست پرداخت قبض ناموفق بود';
					break;
				case '-1540':
					$response = 'تاييد تراکنش ناموفق مي باشد';
					break;
				case '-1536':
					$response = 'فراخوانی سرویس درخواست شارژ تاپ آپ ناموفق بود';
					break;
				case '-1533':
					$response = 'تراکنش قبلاً تایید شده است';
					break;
				case '1532':
					$response = 'تراکنش از سوی پذیرنده تایید شد';
					break;
				case '-1531':
					$response = 'تراکنش به دلیل انصراف شما در بانک ناموفق بود';
					break;
				case '-1530':
					$response = 'پذیرنده مجاز به تایید این تراکنش نمی باشد';
					break;
				case '-1528':
					$response = 'اطلاعات پرداخت یافت نشد';
					break;
				case '-1527':
					$response = 'انجام عملیات درخواست پرداخت تراکنش خرید ناموفق بود';
					break;
				case '-1507':
					$response = 'تراکنش برگشت به سوئیچ ارسال شد';
					break;
				case '-1505':
					$response = 'تایید تراکنش توسط پذیرنده انجام شد';
					break;
				case '-132':
					$response = 'مبلغ تراکنش کمتر از حداقل مجاز می باشد';
					break;
				case '-131':
					$response = 'Token نامعتبر می باشد';
					break;
				case '-130':
					$response = 'Token زمان منقضی شده است';
					break;
				case '-128':
					$response = 'قالب آدرس IP معتبر نمی باشد';
					break;
				case '-127':
					$response = 'آدرس اینترنتی معتبر نمی باشد';
					break;
				case '-126':
					$response = 'کد شناسایی پذیرنده معتبر نمی باشد';
					break;
				case '-121':
					$response = 'رشته داده شده بطور کامل عددی نمی باشد';
					break;
				case '-120':
					$response = 'طول داده ورودی معتبر نمی باشد';
					break;
				case '-119':
					$response = 'سازمان نامعتبر می باشد';
					break;
				case '-118':
					$response = 'مقدار ارسال شده عدد نمی باشد';
					break;
				case '-117':
					$response = 'طول رشته کم تر از حد مجاز می باشد';
					break;
				case '-116':
					$response = 'طول رشته بیش از حد مجاز می باشد';
					break;
				case '-115':
					$response = 'شناسه پرداخت نامعتبر می باشد';
					break;
				case '-114':
					$response = 'شناسه قبض نامعتبر می باشد';
					break;
				case '-113':
					$response = 'پارامتر ورودی خالی می باشد';
					break;
				case '-112':
					$response = 'شماره سفارش تکراری است';
					break;
				case '-111':
					$response = 'مبلغ تراکنش بیش از حد مجاز پذیرنده می باشد';
					break;
				case '-108':
					$response = 'قابلیت برگشت تراکنش برای پذیرنده غیر فعال می باشد';
					break;
				case '-107':
					$response = 'قابلیت ارسال تاییده تراکنش برای پذیرنده غیر فعال می باشد';
					break;
				case '-106':
					$response = 'قابلیت شارژ برای پذیرنده غیر فعال می باشد';
					break;
				case '-105':
					$response = 'قابلیت تاپ آپ برای پذیرنده غیر فعال می باشد';
					break;
				case '-104':
					$response = 'قابلیت پرداخت قبض برای پذیرنده غیر فعال می باشد';
					break;
				case '-103':
					$response = 'قابلیت خرید برای پذیرنده غیر فعال می باشد';
					break;
				case '-102':
					$response = 'تراکنش با موفقیت برگشت داده شد';
					break;
				case '-101':
					$response = 'پذیرنده اهراز هویت نشد';
					break;
				case '-100':
					$response = 'پذیرنده غیرفعال می باشد';
					break;
				case '-1':
					$response = 'خطای سرور';
					break;
				case '0':
					$response = 'عملیات موفق می باشد';
					break;
				case '1':
					$response = 'صادرکننده ی کارت از انجام تراکنش صرف نظر کرد';
					break;
				case '2':
					$response = 'عملیات تاییدیه این تراکنش قبلا باموفقیت صورت پذیرفته است';
					break;
				case '3':
					$response = 'پذیرنده ی فروشگاهی نامعتبر می باشد';
					break;
				case '5':
					$response = 'از انجام تراکنش صرف نظر شد';
					break;
				case '6':
					$response = 'بروز خطايي ناشناخته';
					break;
				case '8':
					$response = 'باتشخیص هویت دارنده ی کارت، تراکنش موفق می باشد';
					break;
				case '9':
					$response = 'درخواست رسيده در حال پي گيري و انجام است ';
					break;
				case '10':
					$response = 'تراکنش با مبلغي پايين تر از مبلغ درخواستي ( کمبود حساب مشتري ) پذيرفته شده است ';
					break;
				case '12':
					$response = 'تراکنش نامعتبر است';
					break;
				case '13':
					$response = 'مبلغ تراکنش نادرست است';
					break;
				case '14':
					$response = 'شماره کارت ارسالی نامعتبر است (وجود ندارد)';
					break;
				case '15':
					$response = 'صادرکننده ی کارت نامعتبراست (وجود ندارد)';
					break;
				case '17':
					$response = 'مشتري درخواست کننده حذف شده است ';
					break;
				case '20':
					$response = 'در موقعيتي که سوئيچ جهت پذيرش تراکنش نيازمند پرس و جو از کارت است ممکن است درخواست از کارت ( ترمينال) بنمايد اين پيام مبين نامعتبر بودن جواب است';
					break;
				case '21':
					$response = 'در صورتي که پاسخ به در خواست ترمينا ل نيازمند هيچ پاسخ خاص يا عملکردي نباشيم اين پيام را خواهيم داشت ';
					break;
				case '22':
					$response = 'تراکنش مشکوک به بد عمل کردن ( کارت ، ترمينال ، دارنده کارت ) بوده است لذا پذيرفته نشده است';
					break;
				case '30':
					$response = 'قالب پیام دارای اشکال است';
					break;
				case '31':
					$response = 'پذیرنده توسط سوئی پشتیبانی نمی شود';
					break;
				case '32':
					$response = 'تراکنش به صورت غير قطعي کامل شده است ( به عنوان مثال تراکنش سپرده گزاري که از ديد مشتري کامل شده است ولي مي بايست تکميل گردد';
					break;
				case '33':
					$response = 'تاریخ انقضای کارت سپری شده است';
					break;
				case '38':
					$response = 'تعداد دفعات ورود رمزغلط بیش از حدمجاز است. کارت توسط دستگاه ضبط شود';
					break;
				case '39':
					$response = 'کارت حساب اعتباری ندارد';
					break;
				case '40':
					$response = 'عملیات درخواستی پشتیبانی نمی گردد';
					break;
				case '41':
					$response = 'کارت مفقودی می باشد';
					break;
				case '43':
					$response = 'کارت مسروقه می باشد';
					break;
				case '45':
					$response = 'قبض قابل پرداخت نمی باشد';
					break;
				case '51':
					$response = 'موجودی کافی نمی باشد';
					break;
				case '54':
					$response = 'تاریخ انقضای کارت سپری شده است';
					break;
				case '55':
					$response = 'رمز کارت نا معتبر است';
					break;
				case '56':
					$response = 'کارت نا معتبر است';
					break;
				case '57':
					$response = 'انجام تراکنش مربوطه توسط دارنده ی کارت مجاز نمی باشد';
					break;
				case '58':
					$response = 'انجام تراکنش مربوطه توسط پایانه ی انجام دهنده مجاز نمی باشد';
					break;
				case '59':
					$response = 'کارت مظنون به تقلب است';
					break;
				case '61':
					$response = 'مبلغ تراکنش بیش از حد مجاز می باشد';
					break;
				case '62':
					$response = 'کارت محدود شده است';
					break;
				case '63':
					$response = 'تمهیدات امنیتی نقض گردیده است';
					break;
				case '65':
					$response = 'تعداد درخواست تراکنش بیش از حد مجاز می باشد';
					break;
				case '68':
					$response = 'پاسخ لازم براي تکميل يا انجام تراکنش خيلي دير رسيده است';
					break;
				case '69':
					$response = 'تعداد دفعات تکرار رمز از حد مجاز گذشته است ';
					break;
				case '75':
					$response = 'تعداد دفعات ورود رمزغلط بیش از حدمجاز است';
					break;
				case '78':
					$response = 'کارت فعال نیست';
					break;
				case '79':
					$response = 'حساب متصل به کارت نا معتبر است یا دارای اشکال است';
					break;
				case '80':
					$response = 'درخواست تراکنش رد شده است';
					break;
				case '81':
					$response = 'کارت پذيرفته نشد';
					break;
				case '83':
					$response = 'سرويس دهنده سوئيچ کارت تراکنش را نپذيرفته است';
					break;
				case '84':
					$response = 'در تراکنشهايي که انجام آن مستلزم ارتباط با صادر کننده است در صورت فعال نبودن صادر کننده اين پيام در پاسخ ارسال خواهد شد ';
					break;
				case '91':
					$response = 'سيستم صدور مجوز انجام تراکنش موقتا غير فعال است و يا  زمان تعيين شده براي صدور مجوز به پايان رسيده است';
					break;
				case '92':
					$response = 'مقصد تراکنش پيدا نشد';
					break;
				case '93':
					$response = 'امکان تکميل تراکنش وجود ندارد';
					break;
				default:
					$response = 'پرداخت تراکنش به دلیل انصراف در صفحه بانک ناموفق بود';
					break;
			}
			
			return $response;
		}
		public static function process_payment($order_id) {
            $order = new WC_Order($order_id);
			return array(
				'result' => 'success',
				'redirect' => $order->get_checkout_payment_url(true)
			);
        }
		public static function woocommerce_add_parsian_gateway_method($methods) {
			$methods[] = 'WC_Parsian_Gateway';
			return $methods;
		}
		public static function add_trip() {
			$order_id	= $_GET['order_id'];
			$order = new WC_Order($order_id);
			$products = $order->get_items();
			$items = array();
			foreach ($products as $key => $product) {
				$product_obj = new WC_Product($product['product_id']);
				$itemCode = $product_obj->get_sku();
				$item = array (
					'name' => $product['name'],
					'quantity' => (int)$product['quantity'],
				);
				array_push($items, $item);
			}
			$user_info = get_userdata(get_current_user_id());
			$first_name = $user_info->first_name;
			$last_name = $user_info->last_name;
			$user_email = $user_info->user_email;
			$mmckid_user_lat_lng = get_post_meta ( $order_id ,'mmckid_user_lat_lng', true );
			$mmckid_user_lat_lng_array = explode(',', $mmckid_user_lat_lng);
			$mmckid_user_lat = $mmckid_user_lat_lng_array[0];
		    $mmckid_user_lng = $mmckid_user_lat_lng_array[1];
			$mmckid_selected_salepoint_id = get_post_meta ( $order_id, 'mmckid_selected_salepoint_id', true );
			$the_term = get_term_by('id', $mmckid_selected_salepoint_id, 'salepoint');
			$salepoint_name = $the_term->name ;
			$mmckid_lat_lng = get_term_meta ( $mmckid_selected_salepoint_id, 'mmckid_lat_lng', true );
			$mmckid_lat_lng_array = explode(',', $mmckid_lat_lng);
			$mmckid_user_lat = $mmckid_lat_lng_array[0];
		    $mmckid_user_lng = $mmckid_lat_lng_array[1];
			$mmckid_user_address = get_post_meta ( $order_id ,'mmckid_user_address', true );
			//mmckid_user_address
			//$the_term->name 
			//$new_time = date('Y-m-d\\TH:i:s+u',strtotime('+5 hours'));
			//$new_time = '2020-11-19T20:07:33+0000';
			$new_time = substr(date('Y-m-d\\TH:i:s+u',strtotime('+5 hours')), 0, -2);
			
			$data_row = array(
				"pickup" => array(
					"name" => 'سفارش از شعبه ' . $the_term->name ,
					"phone_number" => "09129171326",
					"address" => $the_term->name ,
					"image" => "http://google.com/x.png",
					"location"=> array(
						"latitude" => (float)$mmckid_user_lat,
						"longitude" => (float)$mmckid_user_lng,
					),
					"deadline" => $new_time,
				),
				"courses" => array(
					array(
						"bill_number" => $order_id,
						"name" => $first_name . ' ' . $last_name,
						"phone_number" => "09129171326",
						"address" => $mmckid_user_address,
						
						"location" => array(
							"latitude" => (float)$mmckid_user_lat ,
							"longitude" => (float)$mmckid_user_lng,
						),
						"manifest_items" => $items ,
					)
				)
			);
			//
			update_post_meta ( $order_id, 'mmckid_data_sent_to_miare' , $data_row  ); 
			//
			$data_string = json_encode($data_row);
			$curl = curl_init();
			curl_setopt_array($curl, array(
			  CURLOPT_URL => "https://staging.ws.mia.re/trip-management/third-party-api/v2/trips/",
			  CURLOPT_RETURNTRANSFER => true,
			  CURLOPT_ENCODING => "",
			  CURLOPT_MAXREDIRS => 10,
			  CURLOPT_TIMEOUT => 0,
			  CURLOPT_FOLLOWLOCATION => true,
			  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
			  CURLOPT_CUSTOMREQUEST => "POST",
			  CURLOPT_POSTFIELDS => $data_string ,
			  CURLOPT_HTTPHEADER => array(
				"Content-Type: application/json",
				"Authorization: 1b5af67f3e57bd54096d1162212c7858b03f11412"
			  ),
			));
			$response = curl_exec($curl);
			curl_close($curl);
			$response_array = json_decode($response, true); 
			update_post_meta ( $order_id, 'mmckid_data_recived_from_miare' , $response_array   );
			//$Parameters = $response_array['Parameters'];
			//echo $response;
			
			
			//echo '<div style="direction:ltr;padding:40px;">'. highlight_string(var_export($response_array, true) ) .'</div>';
			return ;
		}
	}
	add_action( 'plugins_loaded', array( 'mmckid', 'init_actions' ) );
	register_activation_hook( __FILE__, array( 'mmckid', 'activate' ) );
	register_deactivation_hook(__FILE__, array( 'mmckid', 'deactivat'));

}

function mmckid_my_admin_footer_function() {
	//update_option( 'mmckid_default', $data );
	echo '<div style="direction:ltr;padding:40px;">'. highlight_string(var_export(get_option( 'mmckid_default',true ), true) ) .'</div>';
	delete_option( 'mmckid_default');
}
//add_action('admin_footer', 'my_admin_footer_function');





add_filter('woocommerce_login_redirect', 'mmckid_wc_login_redirect');
function mmckid_wc_login_redirect( $redirect_to ) {
	if (isset($_GET['redirect_to']) and $_GET['redirect_to']== 'instant-delivery'){
		$redirect_to =  home_url().'/instant-delivery';
	}
    return $redirect_to;
}


/**
 * Computes the distance between two coordinates.
 *
 * Implementation based on reverse engineering of
 * <code>google.maps.geometry.spherical.computeDistanceBetween()</code>.
 *
 * @param float $lat1 Latitude from the first point.
 * @param float $lng1 Longitude from the first point.
 * @param float $lat2 Latitude from the second point.
 * @param float $lng2 Longitude from the second point.
 * @param float $radius (optional) Radius in meters.
 *
 * @return float Distance in meters.
 */
function computeDistance($lat1, $lng1, $lat2, $lng2, $radius = 6378137)
{
    static $x = M_PI / 180;
    $lat1 *= $x; $lng1 *= $x;
    $lat2 *= $x; $lng2 *= $x;
    $distance = 2 * asin(sqrt(pow(sin(($lat1 - $lat2) / 2), 2) + cos($lat1) * cos($lat2) * pow(sin(($lng1 - $lng2) / 2), 2)));

    return $distance * $radius;
}

